Enraged = LibStub("AceAddon-3.0"):NewAddon("Enraged","AceConsole-3.0", "AceEvent-3.0");
local media = LibStub("LibSharedMedia-3.0")
local textures = media:List("statusbar")
local fonts = media:List("font")
local AceGUI = LibStub("AceGUI-3.0")

-- Local variables
local enabled
local timeSinceLastUpdate = 0
local updateFrequency = 0.1
local theGCD = 1.5
local inCombat = false
local timeEnteringCombat = 0
local talentSpec = -1 -- Arms (1), Fury (2), Prot (3)
local isEnraged = false
local slots = { [1] = 0, [2] = 0, [3] = 0 }
local slamCount, slamTR

-- Buff info
local enrageET,enrageCount,enrageIcon
local sunderET,sunderCount,sunderIcon
local demoET, demoCount, demoIcon
local thunderET, thunderCount, thunderIcon

local cooldowns = {
  [1] = 0, -- execute
  [2] = 0, -- bloodthirst
  [3] = 0, -- raging blow
  [4] = 0, -- heroic strike
  [5] = 0, -- slam
  [6] = 0, -- colossus smash
  [7] = 0, -- execute 5x
  [8] = 0, -- None
}
local arms_cooldowns = {
  [1] = 0, -- rend
  [2] = 0, -- colossus smash
  [3] = 0, -- mortal strike
  [4] = 0, -- overpower
  [5] = 0, -- execute
  [6] = 0, -- slam
  [7] = 0, -- heroic strike
  [8] = 0, -- hamstring
  [9] = 0, -- none
}
local prot_cooldowns = {
  [1] = 0, -- demo
  [2] = 0, -- shockwave
  [3] = 0, -- victory rush
  [4] = 0, -- revenge
  [5] = 0, -- shield slam
  [6] = 0, -- rend
  [7] = 0, -- thunderclap
  [8] = 0, -- devastate
  [9] = 0, -- heroic strike
  [10] = 0, -- none
}

Enraged.prioritiesFull = { "Execute (0-4 stacks)", "Bloodthirst", "Raging Blow", "Heroic Strike", "Slam", "Colossus Smash", "Execute (5 stacks)", "--------------"}
Enraged.buffsFull = { "Enraged Effects", "Sunder Armor", "Meat Cleaver Stacks", "Demo Shout", "Rend", "Thunder Clap", "Taste for Blood", 
                      "Incite", "Battle Trance", "Executioner Stacks", "Lambs to the Slaughter", "Inner Rage", "Bloodsurge", "Thunderstruck", "Impending Victory", 
                      "T11 Bonus", 
                      "--------------" }
Enraged.prioritiesArms = { "Rend", "Colossus Smash", "Mortal Strike", "Overpower", "Execute", "Slam", "Heroic Strike", "Hamstring", "--------------"}
Enraged.prioritiesProt = { "Demo Shout", "Shockwave", "Victory Rush", "Revenge", "Shield Slam", "Rend", "Thunderclap", "Devastate", "Heroic Strike", "--------------"}

-- Setting of Spell Data
function Enraged:setSpellData(id) 
  local name, _, tex = GetSpellInfo(id); 
  return { id, name, tex } 
 end 
 
-- Spell details shared between specs
Enraged.common = {
	hstrike = { spell = Enraged:setSpellData(78)},    -- Heroic Strike 
	slam    = { spell = Enraged:setSpellData(1464)},  -- Slam
	exec 	  = { spell = Enraged:setSpellData(5308)},  -- Execute
  hthrow  = { spell = Enraged:setSpellData(57755)}, -- Heroic Throw
  csmash  = { spell = Enraged:setSpellData(86346)}, -- Colossus Smash
  incite1 = { spell = Enraged:setSpellData(50685)}, -- Incite Rank 1
  incite2 = { spell = Enraged:setSpellData(50686)}, -- Incite Rank 2
  incite3 = { spell = Enraged:setSpellData(50687)}, -- Incite Rank 3
  exstack = { spell = Enraged:setSpellData(90806)}, -- Executioner
  cleave  = { spell = Enraged:setSpellData(845)},   -- Cleave
  irage   = { spell = Enraged:setSpellData(1134)},  -- Inner Rage
  roa     = { spell = Enraged:setSpellData(90294)}, -- Rage of the Ages 
  hstring = { spell = Enraged:setSpellData(1715)},  -- Hamstring
}
 
 -- Spell details for  Debuffs
Enraged.debuffs = {
  demo   = { spell = Enraged:setSpellData(1160)}, -- Demo Shout
  sunder = { spell = Enraged:setSpellData(7386)}, -- Sunder Armor
  tclap  = { spell = Enraged:setSpellData(6343)}, -- Thunder Clap
  rend   = { spell = Enraged:setSpellData(772)}, -- Rend
}

 -- Spell details for Enraged Effects
Enraged.enraged_effects = {
  berserk   = { spell = Enraged:setSpellData(18499)},  -- Berserker Rage
	deathwish = { spell = Enraged:setSpellData(12292)},  -- Death Wish
  ragebuff  = { spell = Enraged:setSpellData(13046)},  -- Enrage
  reck      = { spell = Enraged:setSpellData(1719)},   -- Recklessness
}

-- Spell details for Fury 
Enraged.fury = {
  bthirst		= { spell = Enraged:setSpellData(23881)}, -- Bloodthirst
  whirlw    = { spell = Enraged:setSpellData(1680)},  -- Whirlwind
  rageblow  = { spell = Enraged:setSpellData(85288)}, -- Raging Blow  
  meatclvr  = { spell = Enraged:setSpellData(12950)}, -- Meat Cleaver
  btrance   = { spell = Enraged:setSpellData(85742)}, -- Battle Trance
  bsurge    = { spell = Enraged:setSpellData(46915)}, -- Bloodsurge (rank 3)
}

-- Spell details for Arms
Enraged.arms = {
  op  = { spell = Enraged:setSpellData(7384)},  -- Overpower
  ms  = { spell = Enraged:setSpellData(12294)}, -- Mortal Strike
  bs  = { spell = Enraged:setSpellData(46924)}, -- Bladestorm
  ss  = { spell = Enraged:setSpellData(12328)}, -- Sweeping Strikes
  tfb = { spell = Enraged:setSpellData(56638)}, -- Taste for Blood
  lamb1 = { spell = Enraged:setSpellData(84584)},   -- Lambs to the Slaughter (rank 1)
  lamb2 = { spell = Enraged:setSpellData(84585)},   -- Lambs to the Slaughter (rank 2)
  lamb3 = { spell = Enraged:setSpellData(84586)},   -- Lambs to the Slaughter (rank 3)
}

Enraged.prot = {
  swave = { spell = Enraged:setSpellData(46968)}, -- Shockwave
  vrush = { spell = Enraged:setSpellData(34428)}, -- Victory Rush
  impend1 = { spell = Enraged:setSpellData(80128)}, -- Impending Victory
  impend2 = { spell = Enraged:setSpellData(80129)}, -- Impending Victory  
  dev     = { spell = Enraged:setSpellData(20243)}, -- Devastate
  shield  = { spell = Enraged:setSpellData(23922)}, -- Shield Slam
  revenge = { spell = Enraged:setSpellData(6572)}, -- Revenge
  tstruck1 = { spell = Enraged:setSpellData(80979)}, -- TStruck1
  tstruck2 = { spell = Enraged:setSpellData(80980)}, -- TStruck2
}

-- Spell Details for Helpfull Shouts
Enraged.shouts = {
  battle  = { spell = Enraged:setSpellData(6673)},  -- Battle Shout
  command = { spell = Enraged:setSpellData(469)},  -- Commanding Shout
}

-- Spell Details for Equivalent Debuffs
Enraged.external = {
  -- Armor Debuffs
  expose   = { spell = Enraged:setSpellData(8647)},    -- Expose Armor (tested)
  ffferal  = { spell = Enraged:setSpellData(16857)},   -- Faerie Fire Feral (tested)
  ff       = { spell = Enraged:setSpellData(770)},     -- Faerie Fire  (tested)
  
  -- Physical Damage Debuffs
  demoroar = { spell = Enraged:setSpellData(99)},      -- Demoralizing Roar - Druid (tested)
  petroar  = { spell = Enraged:setSpellData(50256)},   -- Demoralizing Roar - Hunter pet
  vindic   = { spell = Enraged:setSpellData(26016)},   -- Vindication
  curse    = { spell = Enraged:setSpellData(702)},     -- Curse of Weakness (test)  
  scarlet  = { spell = Enraged:setSpellData(81132)},   -- Expose Armor (test)
  
  -- Attack Speed Debuffs
  frostfever = { spell = Enraged:setSpellData(59921)}, -- Frost Fever (tested)
  judgjust = { spell = Enraged:setSpellData(53696)},   -- Judgment of the Just
  infect   = { spell = Enraged:setSpellData(48484)},   -- Infected Wounds (tested)
  earth    = { spell = Enraged:setSpellData(8042)},    -- Earth Shock  
}
----------------------------------
-- Override the OnUpdate function
----------------------------------
local function OnUpdate(this, elapsed)
	timeSinceLastUpdate = timeSinceLastUpdate + elapsed
  if timeSinceLastUpdate > updateFrequency then  
    Enraged:UpdateMajorBuffs()
    if talentSpec ~= nil and (Enraged.db.profile.enable_fury == true or 
        Enraged.db.profile.enable_arms == true or
        Enraged.db.profile.enable_prot == true) then
      if (talentSpec == 2 and Enraged.db.profile.enable_fury == true) then
        Enraged:UpdateQueue()
      elseif (talentSpec == 1 and Enraged.db.profile.enable_arms == true) then
        Enraged:UpdateQueueArms()
      elseif (talentSpec == 3 and Enraged.db.profile.enable_prot == true) then
        Enraged:UpdateQueueProt()
      end
      Enraged:UpdateCDs()
      Enraged:UpdateOOR()
      if (hsFrame:IsShown() ~= nil) then
        Enraged:UpdateHS()
      end
      Enraged:refreshTextures()
      timeSinceLastUpdate = 0
    end
    if (buffsFrame:IsShown() ~= nil) then
      Enraged:UpdateBuffFrame()
      timeSinceLastUpdate = 0
    end
    
    -- Update Rage Bar
    if (rageFrame:IsShown() ~= nil) then
      local rage = UnitMana("player")
      rageBar:SetValue(rage)
      rageBar.RageText:SetText(UnitMana("player") .. " / 100")    
    end
    
    -- Refresh Textures
    Enraged:refreshTextures()
  end
  
  Enraged.prot_cooldowns = prot_cooldowns
end

------------------------
-- Defaults and Options
------------------------
local defaults = {
    profile = {
        frame_width = 190,
        frame_height = 80,
        frame_x = 400,
        frame_y = 400,
        frame_scale = 1.0,
   
        buff_x = 400,
        buff_y = 300,
        buff_width = 190,
        buff_height = 50,
        buff_scale = 1.0,
        buff_isShown = true,
        buff_isShownArms = true,
        buff_isShownProt = true,

        suggest_thunderclap = false,
        suggest_demo = false,
        suggest_sunder = true,
        suggest_enrage = true,
        suggest_deathwish = false,
        suggest_shout = 2,
        suggest_btrance = true,
        suggest_hs = false,
        suggest_aoe = false,
        
        ragebar_isShown = false,
        rageBar_isShownArms = false,
        rageBar_isShownProt = false,
        ragebar_x = 600,
        ragebar_y = 300,
        ragebar_width = 190,
        ragebar_height = 25,
        
        hsframe_isShown = true,
        hsFrame_isShownArms = true,
        hsFrame_isShownProt = true,
        hsframe_x = 400,
        hsframe_y = 500,
        hsframe_scale = 0.5,
        hsframe_width = 80,
        hsframe_height = 80,
        
        priority_1 = 1, -- Execute
        priority_2 = 2, -- Bloodthirst
        priority_3 = 6, -- Colossus Smash
        priority_4 = 3, -- Raging Blow
        priority_5 = 7, -- Heroic Strike
        priority_6 = 4, -- Slam
        priority_7 = 5, -- 5x Execute
        
        arms_priority_1 = 1, -- Rend
        arms_priority_2 = 2, -- Colossus Smash
        arms_priority_3 = 3, -- Mortal Strike
        arms_priority_4 = 4, -- Overpower
        arms_priority_5 = 5, -- Execute
        arms_priority_6 = 6, -- Slam
        arms_priority_7 = 7, -- Heroic Strike
        arms_priority_8 = 8, -- hamstring
        slam_override = false,
        sd_override = true,
        
        prot_priority_1 = 1, -- 
        prot_priority_2 = 2, -- 
        prot_priority_3 = 3, -- 
        prot_priority_4 = 4, -- 
        prot_priority_5 = 5, -- 
        prot_priority_6 = 6, -- 
        prot_priority_7 = 7, -- 
        prot_priority_8 = 8, -- 
        prot_priority_9 = 9, -- 
        prot_priority_10 = 10, -- 
        sw_stacks = 3,
        time_in_combat = 10,
        revenge_override = true,
		
        buffs_1 = 1, -- Enrage
        buffs_2 = 2, -- Sunder Armor
        buffs_3 = 3, -- Meat Cleaver
        buffs_4 = 4, -- Demo Shout
        
        arms_buffs_1 = 5,
        arms_buffs_2 = 7,
        arms_buffs_3 = 11,
        arms_buffs_4 = 4,
        
        prot_buffs_1 = 4,
        prot_buffs_2 = 6,
        prot_buffs_3 = 2,
        prot_buffs_4 = 14,
        
        hs_threshold = 50,
        hs_threshold_arms = 50,
        hs_threshold_prot = 50,
        ability_buffer = 0.2,
        
        icon_size = 64,
        icon_size_small = 48,
        icon_size_tiny = 32,        
        isLocked = false,
        showOnlyIC = false,
        enabled = true,
        enable_fury = true,
        enable_arms = false,
        enable_prot = true,
    },
}

local options = {
  name = "Enraged",
  handler = Enraged,
  type = "group",
  args = {
    lock = {
      type = "toggle",
      name = "Lock Frames",
      order = 10,
      desc = "Locks the Enraged Frame",
      get = function() return Enraged.db.profile.isLocked end,
      set = "ToggleLocked",
    },
    showOnlyIC = {
      type = "toggle",
      name = "Show only in Combat",
      order = 20,
      desc = "Toggles showing the frames only while in combat",
      get = function() return Enraged.db.profile.showOnlyIC end,
      set = function(self, value) Enraged.db.profile.showOnlyIC = value
            Enraged:EvaluateToggle() end,
    },
    frame = {
      type = "group",
      name = "Ability Queue Frame",
      order = 100,
      args = {
        header = {
          type = "header",
          name = "Ability Queue Frame",
          order = 105,
        },
        scale = {
          type = "range",
          name = "Scale",
          order = 120,
          min = 0.5,
          max = 1.5,
          step = 0.1,
          desc = "Sets the scaling of the Enraged Frame",    
          get = function() return Enraged.db.profile.frame_scale end,
          set = "SetScale",
        },                  
        posx = {
          type = "input",
          name = "X-Coordinate",
          order = 110,
          desc = "Sets the X-Coordinate of the Enraged Frame",
          get = function() return Enraged.db.profile.frame_x end,
          set = "SetXCoord",
        },
        posy = {
          type = "input",
          name = "Y-Coordinate",
          order = 115,
          desc = "Sets the Y-Coordinate of the Enraged Frame",
          get = function() return Enraged.db.profile.frame_y end,
          set = "SetYCoord",
        },
        useShouts = {
          type = "select",
          name = "Rage-Generating Shouts",
          desc = "Will suggest using Battle or Commanding Shout within rotational gaps.",
          order = 135,
          values = { "None", "Battle Shout", "Commanding Shout" },
          get = function() return Enraged.db.profile.suggest_shout end,
          set = function(self, key)  
                  Enraged.db.profile.suggest_shout = key
                end,
          style = "dropdown",
        },
        buffer = {
          type = "range",
          name = "Ability Queue Priority Delay",
          order = 136,
          min = 0.1,
          max = 1.45,
          step = 0.05,
          width = "double",
          desc = "How long we should stall to wait for a higher priority ability. Example: Bloodthirst on 0.2 second cooldown, don't waste the GCD on slam.",    
          get = function() return Enraged.db.profile.ability_buffer end,
          set = function(self, key) Enraged.db.profile.ability_buffer = key end,
        },
        header2 = {
          type = "header",
          name = "Optional Ability Queue Suggestions",
          order = 137,
        },
        useSunder = {
          type = "toggle",
          name = "Sunder Armor",
          desc = "Will suggest using Sunder Armor within rotational gaps.",
          order = 140,
          get = function() return Enraged.db.profile.suggest_sunder end,
          set = function() Enraged.db.profile.suggest_sunder = not Enraged.db.profile.suggest_sunder end,
        },
        useThunderClap = {
          type = "toggle",
          name = "Thunder Clap",
          desc = "Will suggest using Thunder Clap within rotational gaps.",
          order = 155,
          get = function() return Enraged.db.profile.suggest_thunderclap end,
          set = function() Enraged.db.profile.suggest_thunderclap = not Enraged.db.profile.suggest_thunderclap end,
        },
        useDemo = {
          type = "toggle",
          name = "Demoralizing Shout",
          desc = "Will suggest using Demo Shout within rotational gaps.",
          order = 160,
          get = function() return Enraged.db.profile.suggest_demo end,
          set = function() Enraged.db.profile.suggest_demo = not Enraged.db.profile.suggest_demo end,
        },
        useEnrage = {
          type = "toggle",
          name = "Berserker Rage",
          desc = "Will suggest using Berserker Rage within rotational gaps.",
          order = 165,
          get = function() return Enraged.db.profile.suggest_enrage end,
          set = function() Enraged.db.profile.suggest_enrage = not Enraged.db.profile.suggest_enrage end,
        },
        useDeathWish = {
          type = "toggle",
          name = "Death Wish",
          desc = "Will suggest using Death Wish within rotational gaps.",
          order = 170,
          get = function() return Enraged.db.profile.suggest_deathwish end,
          set = function() Enraged.db.profile.suggest_deathwish = not Enraged.db.profile.suggest_deathwish end,
        },
        useHS = {
          type = "toggle",
          name = "Heroic Strike",
          desc = "Will suggest using heroic strike when rage allows",
          order = 175,
          get = function() return Enraged.db.profile.suggest_hs end,
          set = function() Enraged.db.profile.suggest_hs = not Enraged.db.profile.suggest_hs end,
        },
        priority = {
          type = "group",
          name = "Fury Spec Priorities",
          desc = "Priority of abilities in main frame",
          order = 400,
          args = {
            fury_enable = {
              type = "toggle",
              name = "Enable ability queue in Fury Spec",
              width = "double",
              order = 405,
              get = function() return Enraged.db.profile.enable_fury end,
              set = function() 
                      Enraged.db.profile.enable_fury = not Enraged.db.profile.enable_fury 
                      Enraged:EvaluateToggle()
                    end,
            },
            hsThreshold = {
              type = "range",
              name = "Heroic Strike Threshold",
              order = 406,
              min = 30,
              max = 100,
              step = 5,
              desc = "Sets the rage threshold of Heroic Strike",
              get = function() return Enraged.db.profile.hs_threshold end,
              set = function(info,value) Enraged.db.profile.hs_threshold = value end,
            },        
            header = {
              type = "header",
              name = "Ability Priorities",
              order = 410,
            },                    
            priority1 = {
              type = "select",
              name = "Priority #1",
              desc = "DPS Rotation Priority #1",
              order = 430,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_1 end,
              set = function(self, key)  
                      Enraged.db.profile.priority_1 = key
                    end,
              style = "dropdown",            
            },
            priority2 = {
              type = "select",
              name = "Priority #2",
              desc = "DPS Rotation Priority #2",
              order = 440,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_2 end,
              set = function(self, key)  
                      Enraged.db.profile.priority_2 = key
                    end,
              style = "dropdown",            
            },   
            priority3 = {
              type = "select",
              name = "Priority #3",
              desc = "DPS Rotation Priority #3",
              order = 450,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_3 end,
              set = function(self, key)  
                      Enraged.db.profile.priority_3 = key
                    end,
              style = "dropdown",            
            },
            priority4 = {
              type = "select",
              name = "Priority #4",
              desc = "DPS Rotation Priority #4",
              order = 460,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_4 end,
              set = function(self, key)
                      Enraged.db.profile.priority_4 = key
                    end,
              style = "dropdown",            
            },
            priority5 = {
              type = "select",
              name = "Priority #5",
              desc = "DPS Rotation Priority #5",
              order = 470,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_5 end,
              set = function(self, key)
                      Enraged.db.profile.priority_5 = key
                    end,
              style = "dropdown",            
            },
            priority6 = {
              type = "select",
              name = "Priority #6",
              desc = "DPS Rotation Priority #6",
              order = 480,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_6 end,
              set = function(self, key)
                      Enraged.db.profile.priority_6 = key
                    end,
              style = "dropdown",            
            },
            priority7 = {
              type = "select",
              name = "Priority #7",
              desc = "DPS Rotation Priority #7",
              order = 485,
              values = Enraged.prioritiesFull,
              get = function() return Enraged.db.profile.priority_7 end,
              set = function(self, key)
                      Enraged.db.profile.priority_7 = key
                    end,
              style = "dropdown",            
            },           
          },
        },
        arms_priority = {
          type = "group",
          name = "Arms Spec Priorities",
          desc = "Priority of Arms Specialization abilities in main frame",
          order = 500,
          args = {
            arms_enable = {
              type = "toggle",
              name = "Enable ability queue in Arms Spec",
              width = "double",
              order = 505,
              get = function() return Enraged.db.profile.enable_arms end,
              set = function() 
                      Enraged.db.profile.enable_arms = not Enraged.db.profile.enable_arms 
                      Enraged:EvaluateToggle()
                    end,
            },
            slam_toggle = {
              type = "toggle",
              name = "Only suggest slam if Improved Slam talent found",
              width = "double",
              order = 506,
              get = function() return Enraged.db.profile.slam_override end,
              set = function() 
                      Enraged.db.profile.slam_override = not Enraged.db.profile.slam_override 
                    end,
            },
            sd_toggle = {
              type = "toggle",
              name = "Avoid overlapping Colossus Smash debuffs",
              width = "double",
              order = 507,
              get = function() return Enraged.db.profile.sd_override end,
              set = function() 
                      Enraged.db.profile.sd_override = not Enraged.db.profile.sd_override 
                    end,        
            },
            hsThreshold = {
              type = "range",
              name = "Heroic Strike Threshold",
              order = 508,
              min = 30,
              max = 100,
              step = 5,
              desc = "Sets the rage threshold of Heroic Strike",
              get = function() return Enraged.db.profile.hs_threshold_arms end,
              set = function(info,value) Enraged.db.profile.hs_threshold_arms = value end,
            },          
            header = {
              type = "header",
              name = "Ability Priorities",
              order = 510,
            },                    
            priority1 = {
              type = "select",
              name = "Priority #1",
              desc = "DPS Rotation Priority #1",
              order = 520,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_1 end,
              set = function(self, key)
                      Enraged.db.profile.arms_priority_1 = key
                    end,
              style = "dropdown",            
            },
            priority2 = {
              type = "select",
              name = "Priority #2",
              desc = "DPS Rotation Priority #2",
              order = 525,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_2 end,
              set = function(self, key)
                      Enraged.db.profile.arms_priority_2 = key
                    end,
              style = "dropdown",            
            },
            priority3 = {
              type = "select",
              name = "Priority #3",
              desc = "DPS Rotation Priority #3",
              order = 530,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_3 end,
              set = function(self, key)      
                      Enraged.db.profile.arms_priority_3 = key
                    end,
              style = "dropdown",            
            },
            priority4 = {
              type = "select",
              name = "Priority #4",
              desc = "DPS Rotation Priority #4",
              order = 535,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_4 end,
              set = function(self, key)         
                      Enraged.db.profile.arms_priority_4 = key
                    end,
              style = "dropdown",            
            },
            priority5 = {
              type = "select",
              name = "Priority #5",
              desc = "DPS Rotation Priority #5",
              order = 540,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_5 end,
              set = function(self, key)         
                      Enraged.db.profile.arms_priority_5 = key
                    end,
              style = "dropdown",            
            },
            priority6 = {
              type = "select",
              name = "Priority #6",
              desc = "DPS Rotation Priority #6",
              order = 545,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_6 end,
              set = function(self, key)       
                      Enraged.db.profile.arms_priority_6 = key
                    end,
              style = "dropdown",            
            },
            priority7 = {
              type = "select",
              name = "Priority #7",
              desc = "DPS Rotation Priority #7",
              order = 550,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_7 end,
              set = function(self, key)         
                      Enraged.db.profile.arms_priority_7 = key
                    end,
              style = "dropdown",            
            },
            priority8 = {
              type = "select",
              name = "Priority #8",
              desc = "DPS Rotation Priority #8",
              order = 551,
              values = Enraged.prioritiesArms,
              get = function() return Enraged.db.profile.arms_priority_8 end,
              set = function(self, key)         
                      Enraged.db.profile.arms_priority_8 = key
                    end,
              style = "dropdown",            
            },        
          },
        },
        prot_priority = {
          type = "group",
          name = "Prot Spec Priorities",
          desc = "Priority of Protection Specialization abilities in main frame",
          order = 600,
          args = {
            prot_enable = {
              type = "toggle",
              name = "Enable ability queue in Protection Spec",
              width = "double",
              order = 605,
              get = function() return Enraged.db.profile.enable_prot end,
              set = function() 
                      Enraged.db.profile.enable_prot = not Enraged.db.profile.enable_prot
                      Enraged:EvaluateToggle()
                    end,
            },
            shockwave_stacks = {
              type = "select",
              name = "Thunderstruck Stacks",
              desc = "Number of thunderstruck stacks required to suggest shockwave",
              order = 606,
              values = { "1", "2", "3", "None"},
              get = function() return Enraged.db.profile.sw_stacks end,
              set = function(self,key) Enraged.db.profile.sw_stacks = key end,
              style = "dropdown"
            },
            time_in_combat = {
              type = "range",
              name = "Combat Time Before Debuffs",
              desc = "Minimum time spent in combat before recommending missing debuffs. (Rend, Demo Shout, Thunderclap)",
              order = 608,
              min = 0,
              max = 30,
              step = 1,
              width = "double",
              get = function() return Enraged.db.profile.time_in_combat end,
              set = function(self,key) Enraged.db.profile.time_in_combat = key end,
            },
            revenge_toggle = {
              type = "toggle",
              name = "Only suggest revenge if Improved Revenge found",
              width = "double",
              order = 609,
              get = function() return Enraged.db.profile.revenge_override end,
              set = function() 
                      Enraged.db.profile.revenge_override = not Enraged.db.profile.revenge_override 
                    end,
            },
            hsThreshold = {
              type = "range",
              name = "Heroic Strike Threshold",
              order = 610,
              min = 30,
              max = 100,
              step = 5,
              desc = "Sets the rage threshold of Heroic Strike",
              get = function() return Enraged.db.profile.hs_threshold_prot end,
              set = function(info,value) Enraged.db.profile.hs_threshold_prot = value end,
            },         
            header = {
              type = "header",
              name = "Ability Priorities",
              order = 611,
            },                    
            priority1 = {
              type = "select",
              name = "Priority #1",
              desc = "Tank Rotation Priority #1",
              order = 620,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_1 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_1 = key

                    end,
              style = "dropdown",            
            },
            priority2 = {
              type = "select",
              name = "Priority #2",
              desc = "Tank Rotation Priority #2",
              order = 625,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_2 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_2 = key
                    end,
              style = "dropdown",            
            },
            priority3 = {
              type = "select",
              name = "Priority #3",
              desc = "Tank Rotation Priority #3",
              order = 630,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_3 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_3 = key
                    end,
              style = "dropdown",            
            },
            priority4 = {
              type = "select",
              name = "Priority #4",
              desc = "Tank Rotation Priority #4",
              order = 635,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_4 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_4 = key
                    end,
              style = "dropdown",            
            },
            priority5 = {
              type = "select",
              name = "Priority #5",
              desc = "Tank Rotation Priority #5",
              order = 640,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_5 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_5 = key
                    end,
              style = "dropdown",            
            },
            priority6 = {
              type = "select",
              name = "Priority #6",
              desc = "Tank Rotation Priority #6",
              order = 645,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_6 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_6 = key
                    end,
              style = "dropdown",            
            },
            priority7 = {
              type = "select",
              name = "Priority #7",
              desc = "Tank Rotation Priority #7",
              order = 650,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_7 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_7 = key
                    end,
              style = "dropdown",            
            },
            priority8 = {
              type = "select",
              name = "Priority #8",
              desc = "Tank Rotation Priority #8",
              order = 650,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_8 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_8 = key
                    end,
              style = "dropdown",            
            },
            priority9 = {
              type = "select",
              name = "Priority #9",
              desc = "Tank Rotation Priority #9",
              order = 650,
              values = Enraged.prioritiesProt,
              get = function() return Enraged.db.profile.prot_priority_9 end,
              set = function(self, key)
                      Enraged.db.profile.prot_priority_9 = key
                    end,
              style = "dropdown",            
            },
          },
        },        
      },
    },
    buffs = {
      type = "group",
      name = "Buffs / Debuffs Frame",
      order = 200,
      args = {
        header = {
          type = "header",
          name = "Buffs / Debuffs Frame",
          order = 205,
        },           
        toggle = {
          type = "toggle",
          name = "Show in Fury Spec",
          order = 210,
          get = function() return Enraged.db.profile.buff_isShown end,
          set = function(self, key) Enraged.db.profile.buff_isShown = key
                                    Enraged:EvaluateToggle() end,
        },
        toggleArms = {
          type = "toggle",
          name = "Show in Arms Spec",
          order = 211,
          get = function() return Enraged.db.profile.buff_isShownArms end,
          set = function(self, key) Enraged.db.profile.buff_isShownArms = key
                                    Enraged:EvaluateToggle() end,
        },
        toggleProt = {
          type = "toggle",
          name = "Show in Prot Spec",
          order = 212,
          get = function() return Enraged.db.profile.buff_isShownProt end,
          set = function(self, key) Enraged.db.profile.buff_isShownProt = key
                                    Enraged:EvaluateToggle() end,
        },          
        scale = {
          type = "range",
          name = "Scale",
          order = 220,
          min = 0.5,
          max = 1.5,
          step = 0.1,
          desc = "Sets the scaling of the Buffs / Debuffs Frame",    
          get = function() return Enraged.db.profile.buff_scale end,
          set = "SetBuffScale",
        },                  
        posx = {
          type = "input",
          name = "X-Coordinate",
          order = 230,
          desc = "Sets the X-Coordinate of the Buffs / Debuffs Frame",
          get = function() return Enraged.db.profile.buff_x end,
          set = "SetBuffXCoord",
        },
        posy = {
          type = "input",
          name = "Y-Coordinate",
          order = 240,
          desc = "Sets the Y-Coordinate of the Buffs / Debuffs Frame",
          get = function() return Enraged.db.profile.buff_y end,
          set = "SetBuffYCoord",
        },
        furyGroup = {
          type = "group",
          name = "Fury Buffs / Debuffs",
          args = {
            headerFury = {
              type = "header",
              name = "Fury Spec Buffs/Debuffs",
              order = 241,
            },
            buff1 = {
              type = "select",
              name = "Buff #1",
              desc = "Custom Buff #1",
              order = 251,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.buffs_1 end,
              set = function(self, key)  
                      Enraged.db.profile.buffs_1 = key
                    end,
              style = "dropdown",            
            },
            buff2 = {
              type = "select",
              name = "Buff #2",
              desc = "Custom Buff #2",
              order = 251,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.buffs_2 end,
              set = function(self, key)  
                      Enraged.db.profile.buffs_2 = key
                    end,
              style = "dropdown",            
            },
            buff3 = {
              type = "select",
              name = "Buff #3",
              desc = "Custom Buff #3",
              order = 251,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.buffs_3 end,
              set = function(self, key)  
                      Enraged.db.profile.buffs_3 = key
                    end,
              style = "dropdown",            
            },
            buff4 = {
              type = "select",
              name = "Buff #4",
              desc = "Custom Buff #4",
              order = 251,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.buffs_4 end,
              set = function(self, key)  
                      Enraged.db.profile.buffs_4 = key
                    end,
              style = "dropdown",            
            },          
          },
        },
        armsGroup = {
          type = "group",
          name = "Arms Buffs/Debuffs",
          args = {
            -- arms
            headerArms = {
              type = "header",
              name = "Arms Spec Buffs/Debuffs",
              order = 252,
            },
            arms_buff1 = {
              type = "select",
              name = "Buff #1",
              desc = "Custom Buff #1",
              order = 253,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.arms_buffs_1 end,
              set = function(self, key)  
                      Enraged.db.profile.arms_buffs_1 = key
                    end,
              style = "dropdown",            
            },
            arms_buff2 = {
              type = "select",
              name = "Buff #2",
              desc = "Custom Buff #2",
              order = 253,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.arms_buffs_2 end,
              set = function(self, key)  
                      Enraged.db.profile.arms_buffs_2 = key
                    end,
              style = "dropdown",            
            },
            arms_buff3 = {
              type = "select",
              name = "Buff #3",
              desc = "Custom Buff #3",
              order = 253,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.arms_buffs_3 end,
              set = function(self, key)  
                      Enraged.db.profile.arms_buffs_3 = key
                    end,
              style = "dropdown",            
            },
            arms_buff4 = {
              type = "select",
              name = "Buff #4",
              desc = "Custom Buff #4",
              order = 253,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.arms_buffs_4 end,
              set = function(self, key)  
                      Enraged.db.profile.arms_buffs_4 = key
                    end,
              style = "dropdown",            
            },          
          },
        },
        protGroup = {
          type = "group",
          name = "Prot Buffs/Debuffs",
          args = {
            -- prot
            headerProt = {
              type = "header",
              name = "Protection Spec Buffs/Debuffs",
              order = 254,
            },
            prot_buff1 = {
              type = "select",
              name = "Buff #1",
              desc = "Custom Buff #1",
              order = 255,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.prot_buffs_1 end,
              set = function(self, key)  
                      Enraged.db.profile.prot_buffs_1 = key
                    end,
              style = "dropdown",            
            },
            prot_buff2 = {
              type = "select",
              name = "Buff #2",
              desc = "Custom Buff #2",
              order = 255,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.prot_buffs_2 end,
              set = function(self, key)  
                      Enraged.db.profile.prot_buffs_2 = key
                    end,
              style = "dropdown",            
            },
            prot_buff3 = {
              type = "select",
              name = "Buff #3",
              desc = "Custom Buff #3",
              order = 255,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.prot_buffs_3 end,
              set = function(self, key)  
                      Enraged.db.profile.prot_buffs_3 = key
                    end,
              style = "dropdown",            
            },
            prot_buff4 = {
              type = "select",
              name = "Buff #4",
              desc = "Custom Buff #4",
              order = 255,
              values = Enraged.buffsFull,
              get = function() return Enraged.db.profile.prot_buffs_4 end,
              set = function(self, key)  
                      Enraged.db.profile.prot_buffs_4 = key
                    end,
              style = "dropdown",            
            },          
          },
        },
      },
    },
    hsframe = {
      type = "group",
      name = "HS / Cleave Frame",
      desc = "Configuration for the Heroic Strike / Cleave Frame",
      order = 280,
      args = {
        header = {
          type = "header",
          name = "Heroic Strike / Cleave Frame",
          order = 281,      
        },
        toggle = {
          type = "toggle",
          name = "Show in Fury Spec",
          order = 282,
          get = function() return Enraged.db.profile.hsframe_isShown end,
          set = function(self, key) Enraged.db.profile.hsframe_isShown = key
                                    Enraged:EvaluateToggle() end,
        },
        toggleArms = {
          type = "toggle",
          name = "Show in Arms Spec",
          order = 283,
          get = function() return Enraged.db.profile.hsFrame_isShownArms end,
          set = function(self, key) Enraged.db.profile.hsFrame_isShownArms = key
                                    Enraged:EvaluateToggle() end,
        },
        toggleProt = {
          type = "toggle",
          name = "Show in Prot Spec",
          order = 284,
          get = function() return Enraged.db.profile.hsFrame_isShownProt end,
          set = function(self, key) Enraged.db.profile.hsFrame_isShownProt = key
                                    Enraged:EvaluateToggle() end,
        }, 
        scale = {
          type = "range",
          name = "Scale",
          order = 285,
          min = 0.5,
          max = 1.5,
          step = 0.1,
          desc = "Sets the scaling of the HS/Cleave Frame",    
          get = function() return Enraged.db.profile.hsframe_scale end,
          set = "SetHSScale",
        },
        useAOE = {
          type = "toggle",
          name = "Suggest Cleave during Meat Cleaver",
          desc = "Will suggest using during Meat Cleaver stacks (Fury)",
          order = 286,
          width = "double",
          get = function() return Enraged.db.profile.suggest_aoe end,
          set = function() Enraged.db.profile.suggest_aoe = not Enraged.db.profile.suggest_aoe end,
        },
        useBtrance = {
          type = "toggle",
          name = "Reduce HS Threshold during Battle Trance",
          desc = "Will reduce the Heroic Strike Threshold during Battle Trance procs",
          order = 287,
          width = "double",
          get = function() return Enraged.db.profile.suggest_btrance end,
          set = function() Enraged.db.profile.suggest_btrance = not Enraged.db.profile.suggest_btrance end,
        },        
      },
    },
    ragebar = {
      type = "group",
      name = "Rage Bar Frame",
      desc = "Configuration for the Rage Bar Frame",
      order = 300,
      args = {
        header = {
          type = "header",
          name = "Rage Bar Frame",
          order = 310,
        },          
        toggle = {
          type = "toggle",
          name = "Show in Fury Spec",
          order = 311,
          get = function() return Enraged.db.profile.ragebar_isShown end,
          set = function(self, key) Enraged.db.profile.ragebar_isShown = key
                                    Enraged:EvaluateToggle() end,
        },
        toggleArms = {
          type = "toggle",
          name = "Show in Arms Spec",
          order = 312,
          get = function() return Enraged.db.profile.rageBar_isShownArms end,
          set = function(self, key) Enraged.db.profile.rageBar_isShownArms = key
                                    Enraged:EvaluateToggle() end,
        },
        toggleProt = {
          type = "toggle",
          name = "Show in Prot Spec",
          order = 313,
          get = function() return Enraged.db.profile.rageBar_isShownProt end,
          set = function(self, key) Enraged.db.profile.rageBar_isShownProt = key
                                    Enraged:EvaluateToggle() end,
        },  
      },
    },
  },
}

local options2 = {
  name = "Enraged",
  type = "group",
  args = {
    loadGUI = {
      type = "execute",
      name = "Configure",
      desc = "Loads the Enraged Configuration GUI",
      func = function() 
               LibStub("AceConfigDialog-3.0"):Open("Enraged", Enraged.optionFrame) 
             end,
    },
  },
}

-----------------------------------------------
-- Frame initializing for Enraged, Buffs, RageBar
------------------------------------------------
function Enraged:InitEnragedFrame()
  -- Enraged and Ability Frames
  local EnragedFrame = CreateFrame("Frame", "enragedFrame", UIParent)
  self.frame = EnragedFrame
  
  EnragedFrame.Ability1Frame = CreateFrame("Frame", "ability1Frame", EnragedFrame)
  EnragedFrame.Ability2Frame = CreateFrame("Frame", "ability2Frame", EnragedFrame)  
  EnragedFrame.Ability3Frame = CreateFrame("Frame", "ability3Frame", EnragedFrame)
  
  -- Set Frame Strata and load background
  EnragedFrame:SetFrameStrata("BACKGROUND")
  EnragedFrame:SetWidth(self.db.profile.frame_scale * self.db.profile.frame_width)
  EnragedFrame:SetHeight(self.db.profile.frame_scale * self.db.profile.frame_height)
  
  -- Set the Backdrop
	EnragedFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = nil,
		tile = true, tileSize = 4, edgeSize = 0,
		insets = { left = 1, right = 1, top = 1, bottom = 1 }
	})
  if (self.db.profile.isLocked == true) then
      EnragedFrame:SetBackdropColor(0, 0, 0, 0)
  else
      EnragedFrame:SetBackdropColor(0, 0, 0, 0.7)
  end
  
  -- Create Frames for Abilities #1
  EnragedFrame.Ability1Frame.ability = Enraged.fury.bthirst -- Default
	EnragedFrame.Ability1Frame:SetWidth(self.db.profile.icon_size * self.db.profile.frame_scale)
	EnragedFrame.Ability1Frame:SetHeight(self.db.profile.icon_size * self.db.profile.frame_scale)
  EnragedFrame.Ability1Frame:ClearAllPoints()
  EnragedFrame.Ability1Frame:SetPoint("BOTTOMLEFT", EnragedFrame, "BOTTOMLEFT", 8 * self.db.profile.frame_scale, 8 * self.db.profile.frame_scale)
  EnragedFrame.Ability1Frame.texture = EnragedFrame.Ability1Frame:CreateTexture(nil, "OVERLAY")
  EnragedFrame.Ability1Frame.texture:SetTexture(EnragedFrame.Ability1Frame.ability.spell[3])
  EnragedFrame.Ability1Frame.texture:SetWidth(self.db.profile.icon_size * self.db.profile.frame_scale)
  EnragedFrame.Ability1Frame.texture:SetHeight(self.db.profile.icon_size * self.db.profile.frame_scale)
	EnragedFrame.Ability1Frame.texture:ClearAllPoints() 
	EnragedFrame.Ability1Frame.cooldown = CreateFrame("Cooldown","Ability1Cooldown",Ability1Frame)
	EnragedFrame.Ability1Frame.cooldown:SetAllPoints(EnragedFrame.Ability1Frame)
	EnragedFrame.Ability1Frame.cooldown:SetDrawEdge(enable)
  EnragedFrame.Ability1Frame.texture:SetPoint("BOTTOMLEFT", EnragedFrame.Ability1Frame, "BOTTOMLEFT")
  
  -- Create Frames for Abilities #2
  EnragedFrame.Ability2Frame.ability = Enraged.fury.rageblow -- Default
	EnragedFrame.Ability2Frame:SetWidth(self.db.profile.icon_size_small * self.db.profile.frame_scale)
	EnragedFrame.Ability2Frame:SetHeight(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  EnragedFrame.Ability2Frame:ClearAllPoints()
  EnragedFrame.Ability2Frame:SetPoint("BOTTOMLEFT", EnragedFrame, "BOTTOMLEFT", 80 * self.db.profile.frame_scale, 8 * self.db.profile.frame_scale)
  EnragedFrame.Ability2Frame.texture = EnragedFrame.Ability2Frame:CreateTexture(nil, "OVERLAY")
  EnragedFrame.Ability2Frame.texture:SetTexture(EnragedFrame.Ability2Frame.ability.spell[3])
  EnragedFrame.Ability2Frame.texture:SetWidth(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  EnragedFrame.Ability2Frame.texture:SetHeight(self.db.profile.icon_size_small * self.db.profile.frame_scale)
	EnragedFrame.Ability2Frame.texture:ClearAllPoints() 
	EnragedFrame.Ability2Frame.cooldown = CreateFrame("Cooldown","Ability2Cooldown",Ability2Frame)	
	EnragedFrame.Ability2Frame.cooldown:SetDrawEdge(enable)	
  EnragedFrame.Ability2Frame.cooldown:SetAllPoints(EnragedFrame.Ability2Frame)
  EnragedFrame.Ability2Frame.texture:SetPoint("BOTTOMLEFT", EnragedFrame.Ability2Frame, "BOTTOMLEFT")

  -- Create Frames for Abilities #3
  EnragedFrame.Ability3Frame.ability = Enraged.fury.bthirst -- Default  
	EnragedFrame.Ability3Frame:SetWidth(self.db.profile.icon_size_small * self.db.profile.frame_scale)
	EnragedFrame.Ability3Frame:SetHeight(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  EnragedFrame.Ability3Frame:ClearAllPoints()
  EnragedFrame.Ability3Frame:SetPoint("BOTTOMLEFT", EnragedFrame, "BOTTOMLEFT", 136 * self.db.profile.frame_scale, 8 * self.db.profile.frame_scale)
  EnragedFrame.Ability3Frame.texture = EnragedFrame.Ability3Frame:CreateTexture(nil, "OVERLAY")
  EnragedFrame.Ability3Frame.texture:SetTexture(EnragedFrame.Ability3Frame.ability.spell[3])
  EnragedFrame.Ability3Frame.texture:SetWidth(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  EnragedFrame.Ability3Frame.texture:SetHeight(self.db.profile.icon_size_small * self.db.profile.frame_scale)
	EnragedFrame.Ability3Frame.texture:ClearAllPoints() 
	EnragedFrame.Ability3Frame.cooldown = CreateFrame("Cooldown","Ability3Cooldown",Ability3Frame)	
  EnragedFrame.Ability3Frame.cooldown:SetAllPoints(EnragedFrame.Ability3Frame)
	EnragedFrame.Ability3Frame.cooldown:SetDrawEdge(enable)				
  EnragedFrame.Ability3Frame.texture:SetPoint("BOTTOMLEFT", EnragedFrame.Ability3Frame, "BOTTOMLEFT")
  
  -- AOE Frame
  -- Check Box
  EnragedFrame.aoeToggle = AceGUI:Create("CheckBox")
  EnragedFrame.aoeToggle:SetLabel("AOE")
  EnragedFrame.aoeToggle:SetType("checkbox")
  EnragedFrame.aoeToggle:SetValue(true)
  EnragedFrame.aoeToggle.frame:ClearAllPoints()
  EnragedFrame.aoeToggle.frame:SetPoint("BOTTOMLEFT", EnragedFrame, "BOTTOMLEFT", 190 * Enraged.db.profile.frame_scale, 0)
  EnragedFrame.aoeToggle.frame:Show()
  
  -- Set X/Y points, enable mouse 
  EnragedFrame:ClearAllPoints()
  EnragedFrame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.frame_x,self.db.profile.frame_y)
	EnragedFrame:EnableMouse(true)
	EnragedFrame:SetMovable(true)
	EnragedFrame:SetClampedToScreen(true)
	EnragedFrame:RegisterForDrag("LeftButton")
	EnragedFrame:SetScript("OnDragStart", function()
		EnragedFrame:StartMoving()
	end) 
  EnragedFrame:SetScript("OnDragStop", function()
    EnragedFrame:StopMovingOrSizing()
    self.db.profile.frame_x = EnragedFrame:GetLeft()
    self.db.profile.frame_y = EnragedFrame:GetTop()
    EnragedFrame.aoeToggle.frame:ClearAllPoints()
    EnragedFrame.aoeToggle.frame:SetPoint("BOTTOMLEFT", enragedFrame, "BOTTOMLEFT", 190 * Enraged.db.profile.frame_scale, 0)
  end)  
  
  -- Check DB profile for locked and shown status
  if (self.db.profile.isLocked == true) then
    EnragedFrame:EnableMouse(false)
  else
    EnragedFrame:EnableMouse(true)
  end
  
  -- Set up OnUpdate
  self.frame:SetScript("OnUpdate", OnUpdate)  
end

function Enraged:InitBuffsFrame()
  local BuffsFrame = CreateFrame("Frame", "buffsFrame", UIParent)

  self.buffframe = BuffsFrame
  BuffsFrame.enrage  = CreateFrame("Frame", "buffsEnrage", BuffsFrame)
  BuffsFrame.sunder  = CreateFrame("Frame", "buffsSunder", BuffsFrame)  
  BuffsFrame.thunder = CreateFrame("Frame", "buffsThunder", BuffsFrame)
  BuffsFrame.demo    = CreateFrame("Frame", "buffsDemo", BuffsFrame)  
  
  -- Set Frame Strata and load background
  BuffsFrame:SetFrameStrata("BACKGROUND")
  BuffsFrame.enrage:SetFrameStrata("BACKGROUND")
  BuffsFrame.sunder:SetFrameStrata("BACKGROUND")
  BuffsFrame.thunder:SetFrameStrata("BACKGROUND")
  BuffsFrame.demo:SetFrameStrata("BACKGROUND")  
  BuffsFrame:SetWidth(self.db.profile.buff_scale * self.db.profile.buff_width)
  BuffsFrame:SetHeight(self.db.profile.buff_scale * self.db.profile.buff_height)
  
  -- Set the Backdrop
	BuffsFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = nil,
		tile = true, tileSize = 4, edgeSize = 0,
		insets = { left = 1, right = 1, top = 1, bottom = 1 }
	})
  if (self.db.profile.isLocked == true) then
    BuffsFrame:SetBackdropColor(0, 0, 0, 0)
  else
      BuffsFrame:SetBackdropColor(0, 0, 0, 0.7)
  end
  
  -- Buffs Enrage Frame (Set Ability, width, height, texture)
  BuffsFrame.enrage.ability = Enraged.enraged_effects.deathwish -- Default
	BuffsFrame.enrage:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.enrage:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.enrage:ClearAllPoints()
  BuffsFrame.enrage:SetPoint("BOTTOMLEFT", BuffsFrame, "BOTTOMLEFT", 13 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  BuffsFrame.enrage.texture = BuffsFrame.enrage:CreateTexture(nil, "OVERLAY")
  BuffsFrame.enrage.texture:SetTexture(BuffsFrame.enrage.ability.spell[3])
  BuffsFrame.enrage.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.enrage.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.enrage.texture:ClearAllPoints() 
  BuffsFrame.enrage.texture:SetPoint("BOTTOMLEFT", BuffsFrame.enrage, "BOTTOMLEFT")
  
  -- Buffs Sunder Frame (Set Ability, width, height, texture)  
  BuffsFrame.sunder.ability = Enraged.debuffs.sunder -- Default
	BuffsFrame.sunder:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.sunder:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.sunder:ClearAllPoints()
  BuffsFrame.sunder:SetPoint("BOTTOMLEFT", BuffsFrame, "BOTTOMLEFT", 57 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  BuffsFrame.sunder.texture = BuffsFrame.sunder:CreateTexture(nil, "OVERLAY")
  BuffsFrame.sunder.texture:SetTexture(BuffsFrame.sunder.ability.spell[3])
  BuffsFrame.sunder.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.sunder.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.sunder.texture:ClearAllPoints() 
  BuffsFrame.sunder.texture:SetPoint("BOTTOMLEFT", BuffsFrame.sunder, "BOTTOMLEFT")
  
  -- Buffs Thunder Frame (Set Ability, width, height, texture)  
  BuffsFrame.thunder.ability = Enraged.debuffs.tclap -- Default
	BuffsFrame.thunder:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.thunder:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.thunder:ClearAllPoints()
  BuffsFrame.thunder:SetPoint("BOTTOMLEFT", BuffsFrame, "BOTTOMLEFT", 101 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  BuffsFrame.thunder.texture = BuffsFrame.thunder:CreateTexture(nil, "OVERLAY")
  BuffsFrame.thunder.texture:SetTexture(BuffsFrame.thunder.ability.spell[3])
  BuffsFrame.thunder.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.thunder.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.thunder.texture:ClearAllPoints() 
  BuffsFrame.thunder.texture:SetPoint("BOTTOMLEFT", BuffsFrame.thunder, "BOTTOMLEFT")

  -- Buffs Demo Frame (Set Ability, width, height, texture)  
  BuffsFrame.demo.ability = Enraged.debuffs.demo -- Default
	BuffsFrame.demo:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.demo:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.demo:ClearAllPoints()
  BuffsFrame.demo:SetPoint("BOTTOMLEFT", BuffsFrame, "BOTTOMLEFT", 145 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  BuffsFrame.demo.texture = BuffsFrame.demo:CreateTexture(nil, "OVERLAY")
  BuffsFrame.demo.texture:SetTexture(BuffsFrame.demo.ability.spell[3])
  BuffsFrame.demo.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  BuffsFrame.demo.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
	BuffsFrame.demo.texture:ClearAllPoints() 
  BuffsFrame.demo.texture:SetPoint("BOTTOMLEFT", BuffsFrame.demo, "BOTTOMLEFT")  

  -- Setup the Buffs Frame
  BuffsFrame:ClearAllPoints()
  BuffsFrame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.buff_x,self.db.profile.buff_y)
	BuffsFrame:EnableMouse(true)
	BuffsFrame:SetMovable(true)
	BuffsFrame:SetClampedToScreen(true)
	BuffsFrame:RegisterForDrag("LeftButton")
	BuffsFrame:SetScript("OnDragStart", function()
		BuffsFrame:StartMoving()
	end) 
  BuffsFrame:SetScript("OnDragStop", function()
    BuffsFrame:StopMovingOrSizing()
    self.db.profile.buff_x = BuffsFrame:GetLeft()
    self.db.profile.buff_y = BuffsFrame:GetTop()
  end)  
  
  -- Overlay text for the timers
	local text1 = buffsEnrage:CreateFontString(nil, "OVERLAY")
	text1:ClearAllPoints()
	text1:SetPoint("LEFT", buffsEnrage, "LEFT", 6 * self.db.profile.buff_scale, 0)
	text1:SetJustifyH("CENTER")
	text1:SetFont("Fonts\\FRIZQT__.TTF", 12  * self.db.profile.buff_scale, "OUTLINE")
  text1:SetText("")
	buffsEnrage.time = text1

	local text2 = buffsSunder:CreateFontString(nil, "OVERLAY")
	text2:ClearAllPoints()
	text2:SetPoint("LEFT", buffsSunder, "LEFT", 6 * self.db.profile.buff_scale, 0)
	text2:SetJustifyH("CENTER")
	text2:SetFont("Fonts\\FRIZQT__.TTF", 12  * self.db.profile.buff_scale, "OUTLINE")
  text2:SetText("")
	buffsSunder.time = text2
  
	local text3 = buffsThunder:CreateFontString(nil, "OVERLAY")
	text3:ClearAllPoints()
	text3:SetPoint("LEFT", buffsThunder, "LEFT", 6 * self.db.profile.buff_scale, 0)
	text3:SetJustifyH("CENTER")
	text3:SetFont("Fonts\\FRIZQT__.TTF", 12  * self.db.profile.buff_scale, "OUTLINE")
  text3:SetText("")
	buffsThunder.time = text3

	local text4 = buffsDemo:CreateFontString(nil, "OVERLAY")
	text4:ClearAllPoints()
	text4:SetPoint("LEFT", buffsDemo, "LEFT", 6 * self.db.profile.buff_scale, 0)
	text4:SetJustifyH("CENTER")
	text4:SetFont("Fonts\\FRIZQT__.TTF", 12  * self.db.profile.buff_scale, "OUTLINE")
  text3:SetText("")
	buffsDemo.time = text4
  
	local text5 = buffsSunder:CreateFontString(nil, "OVERLAY")
	text5:ClearAllPoints()
	text5:SetPoint("BOTTOMRIGHT", buffsSunder, "BOTTOMRIGHT", -1  * self.db.profile.buff_scale, 1  * self.db.profile.buff_scale)
	text5:SetJustifyH("CENTER")
	text5:SetFont("Fonts\\FRIZQT__.TTF", 10  * self.db.profile.buff_scale, "OUTLINE")
  text5:SetText("")
	buffsSunder.stack = text5
  
	local text6 = buffsEnrage:CreateFontString(nil, "OVERLAY")
	text6:ClearAllPoints()
	text6:SetPoint("BOTTOMRIGHT", buffsEnrage, "BOTTOMRIGHT", -1  * self.db.profile.buff_scale, 1  * self.db.profile.buff_scale)
	text6:SetJustifyH("CENTER")
	text6:SetFont("Fonts\\FRIZQT__.TTF", 10  * self.db.profile.buff_scale, "OUTLINE")
  text6:SetText("")
	buffsEnrage.stack = text6  

	local text7 = buffsThunder:CreateFontString(nil, "OVERLAY")
	text7:ClearAllPoints()
	text7:SetPoint("BOTTOMRIGHT", buffsThunder, "BOTTOMRIGHT", -1  * self.db.profile.buff_scale, 1  * self.db.profile.buff_scale)
	text7:SetJustifyH("CENTER")
	text7:SetFont("Fonts\\FRIZQT__.TTF", 10  * self.db.profile.buff_scale, "OUTLINE")
  text7:SetText("")
	buffsThunder.stack = text7  

	local text8 = buffsDemo:CreateFontString(nil, "OVERLAY")
	text8:ClearAllPoints()
	text8:SetPoint("BOTTOMRIGHT", buffsDemo, "BOTTOMRIGHT", -1  * self.db.profile.buff_scale, 1  * self.db.profile.buff_scale)
	text8:SetJustifyH("CENTER")
	text8:SetFont("Fonts\\FRIZQT__.TTF", 10  * self.db.profile.buff_scale, "OUTLINE")
  text8:SetText("")
	buffsDemo.stack = text8 
  
  if (self.db.profile.isLocked == true) then
    BuffsFrame:EnableMouse(false)
  else
    BuffsFrame:EnableMouse(true)
  end
  
  self.buffframe:SetScript("OnUpdate", OnUpdate)  
end

function Enraged:InitRageFrame()
  local RageFrame = CreateFrame("Frame", "rageFrame", UIParent)
  self.rageframe = RageFrame
  
  -- Set Frame Strata and load background
  RageFrame:ClearAllPoints()
  RageFrame:SetFrameStrata("BACKGROUND")
  RageFrame:SetWidth(190)
  RageFrame:SetHeight(25)
  
  -- Set the Backdrop/Border
	RageFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 4, edgeSize = 14,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
  RageFrame:SetBackdropColor(0, 0, 0, 0.7)
  
  -- Set X/Y points, enable mouse 
  RageFrame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", self.db.profile.ragebar_x, self.db.profile.ragebar_y)
	RageFrame:EnableMouse(true)
	RageFrame:SetMovable(true)
	RageFrame:SetClampedToScreen(true)
	RageFrame:RegisterForDrag("LeftButton")
	RageFrame:SetScript("OnDragStart", function()
		RageFrame:StartMoving()
	end) 
  RageFrame:SetScript("OnDragStop", function()
    RageFrame:StopMovingOrSizing()
    self.db.profile.ragebar_x = RageFrame:GetLeft()
    self.db.profile.ragebar_y = RageFrame:GetTop()
  end)  
  
  -- Create the RageBar
	RageFrame.ragebar = CreateFrame("StatusBar","rageBar",UIParent)
  rageBar:SetWidth(180)
  rageBar:SetHeight(15)
  rageBar:SetPoint("BOTTOMLEFT",RageFrame,"BOTTOMLEFT",5,5)
  rageBar:SetStatusBarTexture(media:Fetch("statusbar",2))  
  rageBar:SetOrientation("HORIZONTAL")
  rageBar:SetMinMaxValues(0, 100)  	
  rageBar:SetValue(UnitMana("player"))
  rageBar:SetStatusBarColor(1,0,0,1)
  
  -- Create the Rage Text
	rageBar.RageText = rageBar:CreateFontString(nil, "OVERLAY")
	rageBar.RageText:ClearAllPoints()
	rageBar.RageText:SetPoint("CENTER", rageBar, "CENTER", 0, 0)
	rageBar.RageText:SetJustifyH("CENTER")
	rageBar.RageText:SetFont("Fonts\\FRIZQT__.TTF", 8)
  rageBar.RageText:SetText(UnitMana("player") .. " / 100")
    
  if (self.db.profile.isLocked == true) then
    RageFrame:EnableMouse(false)
  else
    RageFrame:EnableMouse(true)
  end
end

function Enraged:InitHSFrame()
  -- Enraged and Ability Frames
  local HSFrame = CreateFrame("Frame", "hsFrame", UIParent)
  self.hsFrame = HSFrame
  
  HSFrame.Ability = CreateFrame("Frame", "hsAbilityFrame", HSFrame)
  
  -- Set Frame Strata and load background
  HSFrame:SetFrameStrata("BACKGROUND")
  HSFrame:SetWidth(self.db.profile.hsframe_scale * self.db.profile.hsframe_width)
  HSFrame:SetHeight(self.db.profile.hsframe_scale * self.db.profile.hsframe_height)
  
  -- Set the Backdrop
	HSFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = nil,
		tile = true, tileSize = 4, edgeSize = 0,
		insets = { left = 1, right = 1, top = 1, bottom = 1 }
	})
  if (self.db.profile.isLocked == true) then
      HSFrame:SetBackdropColor(0, 0, 0, 0)
  else
      HSFrame:SetBackdropColor(0, 0, 0, 0.7)
  end
  
  -- Create Frames for Abilities #1
  HSFrame.Ability.spell = Enraged.common.hstrike -- Default
	HSFrame.Ability:SetWidth(self.db.profile.icon_size * self.db.profile.hsframe_scale)
	HSFrame.Ability:SetHeight(self.db.profile.icon_size * self.db.profile.hsframe_scale)
  HSFrame.Ability:ClearAllPoints()
  HSFrame.Ability:SetPoint("BOTTOMLEFT", HSFrame, "BOTTOMLEFT", 8 * self.db.profile.hsframe_scale, 8 * self.db.profile.hsframe_scale)
  HSFrame.Ability.texture = HSFrame.Ability:CreateTexture(nil, "OVERLAY")
  HSFrame.Ability.texture:SetTexture(Enraged.common.hstrike.spell[3])
  HSFrame.Ability.texture:SetWidth(self.db.profile.icon_size * self.db.profile.hsframe_scale)
  HSFrame.Ability.texture:SetHeight(self.db.profile.icon_size * self.db.profile.hsframe_scale)
	HSFrame.Ability.texture:ClearAllPoints() 
	HSFrame.Ability.cooldown = CreateFrame("Cooldown","HSAbilityCooldown",hsAbilityFrame)
	HSFrame.Ability.cooldown:SetAllPoints(HSFrame.Ability)
	HSFrame.Ability.cooldown:SetDrawEdge(enable)
  HSFrame.Ability.texture:SetPoint("BOTTOMLEFT", HSFrame.Ability, "BOTTOMLEFT")
  
  -- Set X/Y points, enable mouse 
  HSFrame:ClearAllPoints()
  HSFrame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.hsframe_x,self.db.profile.hsframe_y)
	HSFrame:EnableMouse(true)
	HSFrame:SetMovable(true)
	HSFrame:SetClampedToScreen(true)
	HSFrame:RegisterForDrag("LeftButton")
	HSFrame:SetScript("OnDragStart", function()
		HSFrame:StartMoving()
	end) 
  HSFrame:SetScript("OnDragStop", function()
    HSFrame:StopMovingOrSizing()
    self.db.profile.hsframe_x = HSFrame:GetLeft()
    self.db.profile.hsframe_y = HSFrame:GetTop()
  end)  
  
  -- Check DB profile for locked and shown status
  if (self.db.profile.isLocked == true) then
    HSFrame:EnableMouse(false)
  else
    HSFrame:EnableMouse(true)
  end  
  
  self.hsFrame:SetScript("OnUpdate", OnUpdate)  
end

---------------------------------------------
-- On Initialized, Enable and Disable Methods
---------------------------------------------
function Enraged:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("EnragedDB", defaults, "Default")
  local className, myClass = UnitClass("player")
  if myClass ~= "WARRIOR" then
    self:Print("You have loaded Enraged on a " .. className .. ". This addon is designed for the Warrior class.")
    enabled = false
		return
  else
    enabled = true
  end  
  
  LibStub("AceConfigDialog-3.0"):SetDefaultSize("Enraged", 600,  500)
  LibStub("AceConfig-3.0"):RegisterOptionsTable("Enraged", options)
  LibStub("AceConfig-3.0"):RegisterOptionsTable("Enraged2", options2)
  self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Enraged2", "Enraged")  
  self:RegisterChatCommand("enr", "ChatCommand")
  self:RegisterChatCommand("enraged", "ChatCommand")
  
	self:RegisterEvent("PLAYER_TALENT_UPDATE")  
	self:RegisterEvent("UNIT_ENTERED_VEHICLE")
	self:RegisterEvent("UNIT_EXITED_VEHICLE")  
  self:RegisterEvent("PLAYER_REGEN_ENABLED")
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    
  self:InitBuffsFrame()  
  self:InitEnragedFrame()
  self:InitRageFrame()
  self:InitHSFrame()
  self:EvaluateToggle()
  self:Print("Loaded. Please type /enr config for the configuration GUI")
end
 
function Enraged:OnEnable()
  talentSpec = GetPrimaryTalentTree()
end

function Enraged:OnDisable()
end

function Enraged:PLAYER_TALENT_UPDATE()
  self:EvaluateToggle()
end

function Enraged:COMBAT_LOG_EVENT_UNFILTERED(self, event, ...)

end

function Enraged:EvaluateToggle()
  -- Get Talent Spec
  talentSpec = GetPrimaryTalentTree()
  if talentSpec == nil then
    self:Print("All frames hidden until a spec is chosen.")
  end
  
  -- If we should show the frame, show it
  if ((Enraged.db.profile.showOnlyIC == true and inCombat == true) or
      (Enraged.db.profile.showOnlyIC == false)) then
    -- Check Ability Frame
    if talentSpec ~= nil and 
       (Enraged.db.profile.enable_arms == true and talentSpec == 1 or 
         Enraged.db.profile.enable_fury == true and talentSpec == 2 or
         Enraged.db.profile.enable_prot == true and talentSpec == 3) then
      self.frame:Show()
      ability1Frame:Show()
      ability2Frame:Show()
      ability3Frame:Show()
      if (talentSpec == 3) then
        enragedFrame.aoeToggle.frame:Show()
      end
    else
      self.frame:Hide()
      ability1Frame:Hide()
      ability2Frame:Hide()
      ability3Frame:Hide()
      enragedFrame.aoeToggle.frame:Hide()
    end
    -- Check Buff Frame
    if talentSpec ~= nil and 
       (Enraged.db.profile.buff_isShown == true and talentSpec == 2 or
       Enraged.db.profile.buff_isShownArms == true and talentSpec == 1 or
       Enraged.db.profile.buff_isShownProt == true and talentSpec == 3) then
      self.buffframe:Show()
    else
      self.buffframe:Hide()
    end
    -- Check Rage Bar Frame
    if talentSpec ~= nil and 
       (Enraged.db.profile.ragebar_isShown == true and talentSpec == 2 or
       Enraged.db.profile.rageBar_isShownArms == true and talentSpec == 1 or
       Enraged.db.profile.rageBar_isShownProt == true and talentSpec == 3) then
      self.rageframe:Show()
      self.rageframe.ragebar:Show()
      self.rageframe.ragebar.RageText:Show()
    else
      self.rageframe:Hide()
      self.rageframe.ragebar:Hide()
      self.rageframe.ragebar.RageText:Hide()    
    end
    -- Check Heroic Strike Frame
    if talentSpec ~= nil and 
       (Enraged.db.profile.hsframe_isShown == true and talentSpec == 2 or
       Enraged.db.profile.hsFrame_isShownArms == true and talentSpec == 1 or
       Enraged.db.profile.hsFrame_isShownProt == true and talentSpec == 3) then
      self.hsFrame:Show()
    else
      self.hsFrame:Hide()
    end
  end
  
  -- Hide Based on in combat
  if (Enraged.db.profile.showOnlyIC == true and inCombat == false) then
    if (self.frame:IsShown() ~= nil) then
      self.frame:Hide()
      ability1Frame:Hide()
      ability2Frame:Hide()
      ability3Frame:Hide()
      enragedFrame.aoeToggle.frame:Hide()
    end
    if (self.buffframe:IsShown() ~= nil) then
      self.buffframe:Hide()
    end
    if (self.rageframe:IsShown() ~= nil) then
      self.rageframe:Hide()
      self.rageframe.ragebar:Hide()
      self.rageframe.ragebar.RageText:Hide()
    end
    if (self.hsFrame:IsShown() ~= nil) then
      self.hsFrame:Hide()
    end      
  end
  
  -- Hide AOE Toggle
  if (talentSpec == 1 or talentSpec == 2) then
    enragedFrame.aoeToggle.frame:Hide()
  end
end

function Enraged:UNIT_ENTERED_VEHICLE()
end
function Enraged:UNIT_EXITED_VEHICLE()
end
function Enraged:PLAYER_REGEN_ENABLED()
  inCombat = false
  Enraged:EvaluateToggle()
end

function Enraged:PLAYER_REGEN_DISABLED()
  inCombat = true
  timeEnteringCombat = GetTime()
  Enraged:EvaluateToggle()
end

-----------------------------------------------------
-- Get and Set of X, Y Coordinates and Width / Height
-----------------------------------------------------
function Enraged:SetXCoord(info, value)
  if (self.db.profile.isLocked == false) then
    self.db.profile.frame_x = value
    self.frame:ClearAllPoints()
    self.frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.frame_x,self.db.profile.frame_y)
  end
end

function Enraged:SetYCoord(info, value)
  if (self.db.profile.isLocked == false) then
    self.db.profile.frame_y = value
    self.frame:ClearAllPoints()
    self.frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.frame_x,self.db.profile.frame_y)
  end
end

function Enraged:SetBuffXCoord(info, value)
  if (self.db.profile.isLocked == false) then
    self.db.profile.buff_x = value
    self.buffframe:ClearAllPoints()
    self.buffframe:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.buff_x,self.db.profile.buff_y)
  end
end

function Enraged:SetBuffYCoord(info, value)
  if (self.db.profile.isLocked == false) then
    self.db.profile.buff_y = value
    self.buffframe:ClearAllPoints()
    self.buffframe:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",self.db.profile.buff_x,self.db.profile.buff_y)
  end
end

----------------------------------------
-- Toggling of Enraged/Buffs Locking
---------------------------------------
function Enraged:ToggleLocked(info, value)
  self.db.profile.isLocked = value
  
  if (self.db.profile.isLocked == true) then
      self.frame:EnableMouse(false)
      self.frame:SetBackdropColor(0, 0, 0, 0)
      buffsFrame:EnableMouse(false)
      buffsFrame:SetBackdropColor(0, 0, 0, 0)
      rageFrame:EnableMouse(false)
      hsFrame:EnableMouse(false)
      hsFrame:SetBackdropColor(0, 0, 0, 0)
  else
      self.frame:EnableMouse(true)
      self.frame:SetBackdropColor(0, 0, 0, 0.7)
      buffsFrame:EnableMouse(true)
      buffsFrame:SetBackdropColor(0, 0, 0, 0.7)
      rageFrame:EnableMouse(true)
      hsFrame:EnableMouse(true)
      hsFrame:SetBackdropColor(0, 0, 0, 0.7)
  end
  
  self:EvaluateToggle()
end

---------------------------------
-- Scale of Enraged/Buffs frames
---------------------------------               
function Enraged:SetScale(info, value)
  self.db.profile.frame_scale = value
  if (tonumber(value) > 1.5 or tonumber(value) < 0.5) then
      self:Print("Scale value out of range (0.5-1.5)")
      return
  end
  enragedFrame:SetWidth(self.db.profile.frame_scale * self.db.profile.frame_width)
  enragedFrame:SetHeight(self.db.profile.frame_scale * self.db.profile.frame_height)
  
  ability1Frame:SetWidth(self.db.profile.frame_scale * self.db.profile.icon_size)
  ability1Frame:SetHeight(self.db.profile.frame_scale * self.db.profile.icon_size)
  ability1Frame:ClearAllPoints()
  ability1Frame:SetPoint("BOTTOMLEFT", enragedFrame, "BOTTOMLEFT", 8 * self.db.profile.frame_scale, 8 * self.db.profile.frame_scale)
  ability1Frame.texture:SetWidth(self.db.profile.icon_size * self.db.profile.frame_scale)
  ability1Frame.texture:SetHeight(self.db.profile.icon_size * self.db.profile.frame_scale)    
  
  ability2Frame:SetWidth(self.db.profile.frame_scale * self.db.profile.icon_size_small)
  ability2Frame:SetHeight(self.db.profile.frame_scale * self.db.profile.icon_size_small)
  ability2Frame:ClearAllPoints()
  ability2Frame:SetPoint("BOTTOMLEFT", enragedFrame, "BOTTOMLEFT", 80 * self.db.profile.frame_scale, 8 * self.db.profile.frame_scale)
  ability2Frame.texture:SetWidth(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  ability2Frame.texture:SetHeight(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  
  ability3Frame:SetWidth(self.db.profile.frame_scale * self.db.profile.icon_size_small)
  ability3Frame:SetHeight(self.db.profile.frame_scale * self.db.profile.icon_size_small)
  ability3Frame:ClearAllPoints()
  ability3Frame:SetPoint("BOTTOMLEFT", enragedFrame, "BOTTOMLEFT", 136 * self.db.profile.frame_scale, 8 * self.db.profile.frame_scale)  
  ability3Frame.texture:SetWidth(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  ability3Frame.texture:SetHeight(self.db.profile.icon_size_small * self.db.profile.frame_scale)
  
  -- AOE Frame
  enragedFrame.aoeToggle.frame:ClearAllPoints()
  enragedFrame.aoeToggle.frame:SetPoint("BOTTOMLEFT", enragedFrame, "BOTTOMLEFT", 190 * Enraged.db.profile.frame_scale, 0)
end

function Enraged:SetBuffScale(info, value)
  self.db.profile.buff_scale = value
  if (tonumber(value) > 1.5 or tonumber(value) < 0.5) then
      self:Print("Scale value out of range (0.5-1.5)")
      return
  end
  
  buffsFrame:SetWidth(self.db.profile.buff_scale * self.db.profile.buff_width)
  buffsFrame:SetHeight(self.db.profile.buff_scale * self.db.profile.buff_height) 
  
  -- Enraged Buff
  buffsEnrage:SetWidth(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsEnrage:SetHeight(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsEnrage:ClearAllPoints()
  buffsEnrage:SetPoint("BOTTOMLEFT", buffsFrame, "BOTTOMLEFT", 13 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  buffsEnrage.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  buffsEnrage.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  
  -- Sunder
  buffsSunder:SetWidth(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsSunder:SetHeight(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsSunder:ClearAllPoints()
  buffsSunder:SetPoint("BOTTOMLEFT", buffsFrame, "BOTTOMLEFT", 57 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  buffsSunder.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  buffsSunder.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)    

  -- Thunder Clap
  buffsThunder:SetWidth(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsThunder:SetHeight(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsThunder:ClearAllPoints()
  buffsThunder:SetPoint("BOTTOMLEFT", buffsFrame, "BOTTOMLEFT", 101 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  buffsThunder.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  buffsThunder.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)    
  
  -- Demo Shout
  buffsDemo:SetWidth(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsDemo:SetHeight(self.db.profile.buff_scale * self.db.profile.icon_size_tiny)
  buffsDemo:ClearAllPoints()
  buffsDemo:SetPoint("BOTTOMLEFT", buffsFrame, "BOTTOMLEFT", 145 * self.db.profile.buff_scale, 8 * self.db.profile.buff_scale)
  buffsDemo.texture:SetWidth(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  buffsDemo.texture:SetHeight(self.db.profile.icon_size_tiny * self.db.profile.buff_scale)
  
  -- Text
  buffsEnrage.time:SetFont("Fonts\\FRIZQT__.TTFa", 12 * self.db.profile.buff_scale, "OUTLINE")
  buffsEnrage.stack:SetFont("Fonts\\FRIZQT__.TTFa", 10 * self.db.profile.buff_scale, "OUTLINE")
  buffsSunder.time:SetFont("Fonts\\FRIZQT__.TTF", 12 * self.db.profile.buff_scale, "OUTLINE")
  buffsSunder.stack:SetFont("Fonts\\FRIZQT__.TTF", 10 * self.db.profile.buff_scale, "OUTLINE")
  buffsThunder.time:SetFont("Fonts\\FRIZQT__.TTF", 12 * self.db.profile.buff_scale, "OUTLINE")
  buffsThunder.stack:SetFont("Fonts\\FRIZQT__.TTF", 10 * self.db.profile.buff_scale, "OUTLINE")
  buffsDemo.time:SetFont("Fonts\\FRIZQT__.TTF", 12 * self.db.profile.buff_scale, "OUTLINE")
  buffsDemo.stack:SetFont("Fonts\\FRIZQT__.TTF", 10 * self.db.profile.buff_scale, "OUTLINE")
end

---------------------------------
-- Scale of HS/Cleave frames
---------------------------------               
function Enraged:SetHSScale(info, value)
  self.db.profile.hsframe_scale = value
  if (tonumber(value) > 1.5 or tonumber(value) < 0.5) then
      self:Print("Scale value out of range (0.5-1.5)")
      return
  end
  hsFrame:SetWidth(self.db.profile.hsframe_scale * self.db.profile.hsframe_width)
  hsFrame:SetHeight(self.db.profile.hsframe_scale * self.db.profile.hsframe_height)
  
  hsFrame.Ability:SetWidth(self.db.profile.hsframe_scale * self.db.profile.icon_size)
  hsFrame.Ability:SetHeight(self.db.profile.hsframe_scale * self.db.profile.icon_size)
  hsFrame.Ability:ClearAllPoints()
  hsFrame.Ability:SetPoint("BOTTOMLEFT", hsFrame, "BOTTOMLEFT", 8 * self.db.profile.hsframe_scale, 8 * self.db.profile.hsframe_scale)
  hsFrame.Ability.texture:SetWidth(self.db.profile.icon_size * self.db.profile.hsframe_scale)
  hsFrame.Ability.texture:SetHeight(self.db.profile.icon_size * self.db.profile.hsframe_scale)    
end

-------------------------------
-- Interpret the Chat Commnads
-------------------------------
function Enraged:ChatCommand(input)
  if input:trim() == "options" or input:trim() == "config" then
    LibStub("AceConfigDialog-3.0"):Open("Enraged", Enraged.optionFrame)
  else
    self:Print("Enraged: Enter \"/enr config\" for configuration GUI")
  end
end

-------------------------------------
-- Toggles Enraged Ability's colours
-- based on their availablility
-------------------------------------
function Enraged:ShowAbilitiesUnavailable(override)
  if (override == false) then
    ability1Frame.texture:SetVertexColor(0.8, 0.1, 0.1)
  else
    ability1Frame.texture:SetVertexColor(1, 1, 1)
  end
  ability2Frame.texture:SetVertexColor(0.8, 0.1, 0.1)
  ability3Frame.texture:SetVertexColor(0.8, 0.1, 0.1)
  Enraged:refreshTextures()        
end

function Enraged:ShowAbilitiesAvailable()
  ability1Frame.texture:SetVertexColor(1, 1, 1)
  ability2Frame.texture:SetVertexColor(1, 1, 1)
  ability3Frame.texture:SetVertexColor(1, 1, 1)
  Enraged:refreshTextures()        
end

------------------------------------
-- Update the DPS Priority Queue (Fury)
------------------------------------
function Enraged:UpdateQueue()
  -- Update Slam Count
  _,_,_,slamCount,_,_,slamTR,_,_,_,_ = UnitAura("player",Enraged.fury.bsurge.spell[2])  
  
  -- Find the current GCD
  local currentStart,currentBaseGCD = GetSpellCooldown(Enraged.debuffs.sunder.spell[1])
  local currentGCD = 0
  if (currentStart > 0) then
    currentGCD = currentBaseGCD - (GetTime() - currentStart)
  else
    currentGCD = 0
  end
  
  -- Set CD's of our spell array back to 0
  Enraged:GetBuffInfo(1) -- Get Enraged Status
  Enraged:UpdateCooldowns(currentGCD)
  
  -- Iterate through 1-3
  for i = 1,3 do
    Enraged:FindLowestCooldown(i)
  end
  
  -- Check for shouts
  if (UnitMana("player") < 20) then
    shout, _, _ = GetSpellCooldown(Enraged.shouts.battle.spell[1])
    if (shout == 0) then
      if (ability1Frame.ability ~= Enraged.fury.rageblow) then
        if (Enraged.db.profile.suggest_shout == 2) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.shouts.battle
        end
        if (Enraged.db.profile.suggest_shout == 3) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.shouts.command
        end
      end
    end
  end
  
  -- Check for Raging Blow
  DW_start, _, _ = GetSpellCooldown(Enraged.enraged_effects.deathwish.spell[1])
  BR_start, _, _ = GetSpellCooldown(Enraged.enraged_effects.berserk.spell[1])
  if (isEnraged == false) then
    -- check slot 1
    if ability1Frame.ability.spell[1] == 85288 then
      if (DW_start == 0) and Enraged.db.profile.suggest_deathwish == true then
        Enraged:pushbackAbilities(1)
        ability1Frame.ability = Enraged.enraged_effects.deathwish
      elseif (BR_start == 0) and Enraged.db.profile.suggest_enrage == true then
        Enraged:pushbackAbilities(1)
        ability1Frame.ability = Enraged.enraged_effects.berserk
      end          
    -- check slot 2
    elseif ability2Frame.ability.spell[1] == 85288 then
      if (DW_start == 0) and Enraged.db.profile.suggest_deathwish == true then
        Enraged:pushbackAbilities(2)
        ability2Frame.ability = Enraged.enraged_effects.deathwish
      elseif (BR_start == 0) and Enraged.db.profile.suggest_enrage == true then
        Enraged:pushbackAbilities(2)
        ability2Frame.ability = Enraged.enraged_effects.berserk   
      end          
    -- check slot 3
    elseif ability3Frame.ability.spell[1] == 85288 then
      if (DW_start == 0) and Enraged.db.profile.suggest_deathwish == true then
        ability3Frame.ability = Enraged.enraged_effects.deathwish
      elseif (BR_start == 0) and Enraged.db.profile.suggest_enrage == true then
        ability3Frame.ability = Enraged.enraged_effects.berserk         
      end          
    end        
  end
  
  -- Check for rotational gaps
  Enraged:updateRotationGaps(currentGCD + Enraged.db.profile.ability_buffer) -- small buffer
end

function Enraged:UpdateCooldowns(currentGCD)
  -- Execute
  local executeStart,executeBaseCD = GetSpellCooldown(Enraged.common.exec.spell[1])
  local executeCD
  if (executeStart > 0) then
    cooldowns[1] = executeBaseCD - (GetTime() - executeStart)
    cooldowns[7] = executeBaseCD - (GetTime() - executeStart)
  else
    cooldowns[1] = 0
    cooldowns[7] = 0
  end
  
  -- Bloodthirst
  local bthirstStart,bthirstBaseCD = GetSpellCooldown(Enraged.fury.bthirst.spell[1])
  local bthirstCD
  if (bthirstStart > 0) then
    cooldowns[2] = bthirstBaseCD - (GetTime() - bthirstStart)
  else
    cooldowns[2] = 0
  end
  -- Raging Blow
  local rblowStart,rblowBaseCD = GetSpellCooldown(Enraged.fury.rageblow.spell[1])
  if (rblowStart > 0) then
    cooldowns[3] = rblowBaseCD - (GetTime() - rblowStart)
  else
    cooldowns[3] = 0
  end
  -- Heroic strike
  local hsStart,hsBaseCD = GetSpellCooldown(Enraged.common.hstrike.spell[1])
  if (hsStart > 0) then
    cooldowns[4] = hsBaseCD - (GetTime() - hsStart)
  else
    cooldowns[4] = 0
  end
  -- Slam
  cooldowns[5] = currentGCD
  -- Colossus Smash
  local csStart, csBaseCD = GetSpellCooldown(Enraged.common.csmash.spell[1])
  if (csStart > 0) then
    cooldowns[6] = csBaseCD - (GetTime() - csStart)
  else
    cooldowns[6] = 0
  end
    
  -- "None"
  cooldowns[8] = 999
end

function Enraged:ValidityCheck(priority)
  -- If the user even wants to display this ability
  if Enraged:GetPriorityByNum(priority) == 999 then
    return 1
  end  
    
  -- Check for Execute Range (0-4 stacks)
  if priority == 1 then
    local _,_,_,execCount,_,_,execET,_,_ = UnitAura("player", Enraged.common.exstack.spell[2])
    
    -- Check Executioner Stacks
    if execCount ~= nil and execCount == 5 and (execET - GetTime() > 3) then
      return 1
    end
    
    local health = UnitHealth("target") -- get health
    if health > 0 then -- make sure we have some valid health
      local maxHealth = UnitHealthMax("target") -- max health
      local hpPC = health / maxHealth -- check their percent
      if (hpPC > 0.2) then
        return 1
      end
    else
      return 1
    end
  end
  
  -- BT
  if priority == 2 then  
  end
  
  -- Raging Blow
  if priority == 3 then
    DW_start, _, _ = GetSpellCooldown(Enraged.enraged_effects.deathwish.spell[1])
    BR_start, _, _ = GetSpellCooldown(Enraged.enraged_effects.berserk.spell[1])
    if isEnraged == false then
      if Enraged.db.profile.suggest_deathwish == true and DW_start == 0 then
        return 0
      elseif Enraged.db.profile.suggest_enrage == true and BR_start == 0 then
        return 0
      else
        return 1
      end
    else
      return 0
    end
  end
  
  -- Heroic Strike
  if priority == 4 then
    if Enraged.db.profile.suggest_hs == false then
      return 1
    end
    
    _,_,_,_,_,_,btET,_,_,_,_ = UnitAura("player","Battle Trance")    
    if (Enraged.db.profile.suggest_btrance == true and btET ~= nil and btET > 0) then
      if (UnitMana("player") < (Enraged.db.profile.hs_threshold - 20)) then
        return 1
      end
    else
      if (UnitMana("player") < Enraged.db.profile.hs_threshold) then
        return 1
      end      
    end
  end
  
  -- Slam (do we have a Bloodsurge proc)
  if (priority == 5) then
    if (slamCount == nil or slamCount == 0) then
      return 1
    end
  end
  
  -- Colossus Smash
  if priority == 6 then
    if (UnitLevel("player") < 81) then
      return 1
    end
  end
  
  -- Check for Execute Range (5 stacks)
  if priority == 7 then 
    local _,_,_,execCount,_,_,execET,_,_ = UnitAura("player", Enraged.common.exstack.spell[2])
    
    -- Check Executioner Stacks
    if execCount == nil or (execCount ~= nil and execCount < 5) then
      return 1
    end
    
    local health = UnitHealth("target") -- get health
    if health > 0 then -- make sure we have some valid health
      local maxHealth = UnitHealthMax("target") -- max health
      local hpPC = health / maxHealth -- check their percent
      if (hpPC > 0.2) then
        return 1
      end
    else
      return 1
    end
  end
  
  -- The "none" is always invalid
  if priority == 8 then
    return 1
  end
  
  return 0
end

function Enraged:GetAbilityByNum(num)
  if num == 1 then -- execute
    return Enraged.common.exec
  end
  if num == 2 then -- bloodthirst
    return Enraged.fury.bthirst
  end
  if num == 3 then -- rage blow
    return Enraged.fury.rageblow
  end
  if num == 4 then -- heroic strike
    return Enraged.common.hstrike
  end
  if num == 5 then -- slam
    return Enraged.common.slam
  end
  if num == 6 then -- colossus smash
    return Enraged.common.csmash
  end
  if num == 7 then
    return Enraged.common.exec
  end
  if num == 8 then
    return Enraged.fury.bthirst -- default, never used
  end
end

function Enraged:IncreaseCooldown(num)
  if num == 1 then -- execute (0-4)
    cooldowns[1] = cooldowns[1] + theGCD
  end
  if num == 2 then -- bloodthirst
    cooldowns[2] = cooldowns[2] + 3
  end
  if num == 3 then -- rage blow
    cooldowns[3] = cooldowns[3] + 6
  end
  if num == 4 then -- heroic strike
    cooldowns[4] = cooldowns[4] + 9 -- we only want to show HS on the bar once
  end                                  -- there is rage to consider after all
  if num == 5 then -- slam
    cooldowns[5] = cooldowns[5] + theGCD
  end
  if num == 6 then -- colossus smash
    cooldowns[6] = cooldowns[6] + 20
  end
  if num == 7 then -- execute (5 stacks)
    cooldowns[7] = cooldowns[7] + theGCD
  end
  if num == 8 then
    cooldowns[8] = 999
  end
end

function Enraged:FindLowestCooldown(slot)
  local lowSlot
  local lowCooldown
  
  -- #1
  if Enraged:ValidityCheck(1) == 0 then
    lowSlot = 1
    lowCooldown = cooldowns[1]
  else
    lowSlot = 1
    lowCooldown = 999
  end
  
  -- #2
  if Enraged:ValidityCheck(2) == 0 then
    if Enraged:ComparePriorities(lowSlot,2) == 0 then
      if cooldowns[2] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 2
        lowCooldown = cooldowns[2]
      end
    else
      if cooldowns[2] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 2
        lowCooldown = cooldowns[2]      
      end
    end
  end
  
  -- #3
  if Enraged:ValidityCheck(3) == 0 then
    if Enraged:ComparePriorities(lowSlot,3) == 0 then
      if cooldowns[3] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 3
        lowCooldown = cooldowns[3]
      end
    else
      if cooldowns[3] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 3
        lowCooldown = cooldowns[3]      
      end
    end
  end
  
  -- #4
  if Enraged:ValidityCheck(4) == 0 then
    if Enraged:ComparePriorities(lowSlot,4) == 0 then
      if cooldowns[4] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 4
        lowCooldown = cooldowns[4]
      end
    else
      if cooldowns[4] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 4
        lowCooldown = cooldowns[4]      
      end
    end
  end
  
  -- #5
  if Enraged:ValidityCheck(5) == 0 then
    if Enraged:ComparePriorities(lowSlot,5) == 0 then
      if cooldowns[5] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 5
        lowCooldown = cooldowns[5]
      end
    else
      if cooldowns[5] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 5
        lowCooldown = cooldowns[5]      
      end
    end
  end
  
  -- #6
  if Enraged:ValidityCheck(6) == 0 then
    if Enraged:ComparePriorities(lowSlot,6) == 0 then
      if cooldowns[6] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 6
        lowCooldown = cooldowns[6]
      end
    else
      if cooldowns[6] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 6
        lowCooldown = cooldowns[6]      
      end
    end
  end
  
  -- #7
  if Enraged:ValidityCheck(7) == 0 then
    if Enraged:ComparePriorities(lowSlot,7) == 0 then
      if cooldowns[7] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 7
        lowCooldown = cooldowns[7]
      end
    else
      if cooldowns[7] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 7
        lowCooldown = cooldowns[7]      
      end
    end
  end
  
  -- Slam
  if lowSlot == 5 then
    slamCount = 0
  end
  
  -- Update Ability
  local ability = Enraged:GetAbilityByNum(lowSlot)
  if slot == 1 then
    ability1Frame.ability = ability
  end
  if slot == 2 then
    ability2Frame.ability = ability
  end
  if slot == 3 then
    ability3Frame.ability = ability
  end 
  
  -- Update Slot and Cooldown
  slots[slot] = 1
  Enraged:IncreaseCooldown(lowSlot)
end

function Enraged:ComparePriorities(lowSlot, newSlot)
  local lowSlotPriority = Enraged:GetPriorityByNum(lowSlot)
  local newSlotPriority = Enraged:GetPriorityByNum(newSlot)
  if (lowSlotPriority < newSlotPriority) then
    return 1
  else
    return 0
  end
end

function Enraged:GetPriorityByNum(slot)
  if Enraged.db.profile.priority_1 == slot then
    return 1
  end
  if Enraged.db.profile.priority_2 == slot then
    return 2
  end
  if Enraged.db.profile.priority_3 == slot then
    return 3
  end
  if Enraged.db.profile.priority_4 == slot then
    return 4
  end
  if Enraged.db.profile.priority_5 == slot then
    return 5
  end
  if Enraged.db.profile.priority_6 == slot then
    return 6
  end
  if Enraged.db.profile.priority_7 == slot then
    return 7
  end
  if Enraged.db.profile.priority_8 == slot then
    return 8
  end
  return 999 -- spell not in list
end

----------------------------------------------------
-- Checks ability slots 1-3 for rotational gaps, and
-- fills them in with a beneficial ability
----------------------------------------------------
function Enraged:updateRotationGaps(currentGCD)
  local ability1Start, ability1BaseCD = GetSpellCooldown(ability1Frame.ability.spell[1])
  local ability1CD = ability1BaseCD - (GetTime() - ability1Start)
  
  Enraged:updateAbility1(ability1CD, currentGCD)
end

function Enraged:updateAbility1(ability1CD, currentGCD)
  -- Sunder Refresh
  if (self.db.profile.suggest_sunder == true) then
    if sunderIcon == Enraged.common.sunder and sunderET ~= nil and sunderET - GetTime() < 3 then
      Enraged:pushbackAbilities(1)
      cSmash,_,_ = GetSpellCooldown(Enraged.common.csmash.spell[1])
      if cSmash < sunderET - GetTime() then
        ability1Frame.ability = Enraged.common.csmash
      else
        ability1Frame.ability = Enraged.debuffs.sunder
        return
      end
    end
  end
  
  if (currentGCD < ability1CD) then
    -- Sunder
    if ((GetTime() - timeEnteringCombat) > 8) then    
      if (self.db.profile.suggest_sunder == true) then
        if sunderIcon.spell[2] == Enraged.debuffs.sunder.spell[2] and (sunderCount == nil or sunderCount < 3) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.debuffs.sunder
          return
        end
      end
    end
    
    -- Check Demo Shout
    if ((GetTime() - timeEnteringCombat) > 8) then
      if (self.db.profile.suggest_demo == true) then
        if (demoET == nil or (demoET - GetTime()) < 3) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.debuffs.demo
          return
        end
      end
    end
    
    -- Check Thunderclap
    if ((GetTime() - timeEnteringCombat) > 8) then
      if (self.db.profile.suggest_thunderclap == true) then
        if (thunderET == nil or (thunderET - GetTime()) < 3) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.debuffs.tclap
          return
        end
      end
    end
  end
end

------------------------------------
-- Update the DPS Priority Queue
------------------------------------
function Enraged:UpdateQueueArms()
  -- Find the current GCD
  local currentStart,currentBaseGCD = GetSpellCooldown(Enraged.debuffs.sunder.spell[1])
  local currentGCD = 0
  if (currentStart > 0) then
    currentGCD = currentBaseGCD - (GetTime() - currentStart)
  else
    currentGCD = 0
  end
  
  -- Update our CD's
  Enraged:UpdateCooldownsArms(currentGCD)
  
  -- Iterate through 1-2
  for i = 1,2 do
    Enraged:FindLowestCooldownArms(i)
  end
  
  -- Check for shouts
  if (UnitMana("player") < 5) then
    shout, _, _ = GetSpellCooldown(Enraged.shouts.battle.spell[1])
    if (shout == 0) then
      if (Enraged.db.profile.suggest_shout == 2) then
        Enraged:pushbackAbilities(1)
        ability1Frame.ability = Enraged.shouts.battle
      end
      if (Enraged.db.profile.suggest_shout == 3) then
        Enraged:pushbackAbilities(1)
        ability1Frame.ability = Enraged.shouts.command
      end
    end
  end
  
  -- Check for rotational gaps
  Enraged:updateRotationGaps(currentGCD + 0.3) -- small buffer
end

function Enraged:UpdateCooldownsArms(currentGCD)
  -- Rend
  arms_cooldowns[1] = currentGCD 
  
  -- Colossus Smash
  local csStart, csBaseCD = GetSpellCooldown(Enraged.common.csmash.spell[1])
  if (csStart > 0) then
    arms_cooldowns[2] = csBaseCD - (GetTime() - csStart)
  else
    arms_cooldowns[2] = 0
  end
  
  -- Mortal Strike
  local msStart,msBaseCD = GetSpellCooldown(Enraged.arms.ms.spell[1])
  if (msStart > 0) then
    arms_cooldowns[3] = msBaseCD - (GetTime() - msStart)
  else
    arms_cooldowns[3] = 0
  end
  
  -- Overpower
  local opStart,opBaseCD = GetSpellCooldown(Enraged.arms.op.spell[1])
  if (opStart > 0) then
    arms_cooldowns[4] = opBaseCD - (GetTime() - opStart)
  else
    arms_cooldowns[4] = 0
  end  
  
  -- Execute
  arms_cooldowns[5] = currentGCD

  -- Slam
  arms_cooldowns[6] = currentGCD
  
  -- Heroic strike
  local hsStart,hsBaseCD = GetSpellCooldown(Enraged.common.hstrike.spell[1])
  if (hsStart > 0) then
    arms_cooldowns[7] = hsBaseCD - (GetTime() - hsStart)
  else
    arms_cooldowns[7] = 0
  end
  
  -- Hamstring
  local hamStart,hamBaseCD = GetSpellCooldown(Enraged.common.hstring.spell[1])
  if (hamStart > 0) then
    arms_cooldowns[8] = hamBaseCD - (GetTime() - hamStart)
  else
    arms_cooldowns[8] = 0
  end
  
  arms_cooldowns[9] = 999
end

function Enraged:ValidityCheckArms(priority)
  -- If the user wants even check this priority
  if Enraged:GetPriorityByNumArms(priority) == 999 then
    return 1
  end
  
    -- Rend
  if (priority == 1) then
    -- If the user even wants to show this ability 
    local _,_,_,rendCount,_,_,rendET,_,_ = UnitDebuff("target", Enraged.debuffs.rend.spell[2])
    if (rendET ~= nil and (rendET - GetTime()) > 1.5) then
      return 1
    end
  end
    
  -- Colossus Smash
  if priority == 2 then
    -- If the user even wants to show this ability
    local _,_,_,csCount,_,_,csET,_,_ = UnitDebuff("target", Enraged.common.csmash.spell[2])
    if (UnitLevel("player") < 81) or
       (Enraged.db.profile.sd_override == true and csET ~= nil and (csET - GetTime() > 1.5)) then
      return 1
    end
  end
  
  if priority == 3 then
  end
  
  -- Taste for Blood
  if priority == 4 then   
    local _,_,_,tfbCount,_,_,tfbET,_,_ = UnitAura("player", Enraged.arms.tfb.spell[2])    
    if (tfbET == nil) then
      return 1
    end
  end  
  
  -- Check for Execute Range
  if priority == 5 then    
    local health = UnitHealth("target") -- get health
    if health > 0 then -- make sure we have some valid health
      local maxHealth = UnitHealthMax("target") -- max health
      local hpPC = health / maxHealth -- check their percent
      if (hpPC > 0.2) then
        return 1
      end
    else
      return 1
    end
  end
  
  -- Slam
  if priority == 6 then  
    local _,_,_,_,rank,_,_,_,_,_ = GetTalentInfo(1,12)
    if (rank == 0 and Enraged.db.profile.slam_override == true) then
      return 1
    end
  end
  
  -- Heroic Strike
  if priority == 7 then  
    if (UnitMana("player") < Enraged.db.profile.hs_threshold_arms) then
      return 1
    end
  end
  
  -- Hamstring
  if priority == 8 then
    local _,_,_,hamCount,_,_,hamET,_,_ = UnitAura("player", Enraged.common.hstring.spell[2])
    if (hamET ~= nil and (hamET - GetTime()) > 3) then
      return 1
    end
  end
  
  -- none, always false
  if priority == 9 then
    return 1
  end
  
  return 0
end

function Enraged:FindLowestCooldownArms(slot)
  local lowSlot
  local lowCooldown
  
  -- #1
  if Enraged:ValidityCheckArms(1) == 0 then
    lowSlot = 1
    lowCooldown = arms_cooldowns[1]
  else
    lowSlot = 1
    lowCooldown = 999
  end
  
-- #2
  if Enraged:ValidityCheckArms(2) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,2) == 0 then
      if arms_cooldowns[2] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 2
        lowCooldown = arms_cooldowns[2]
      end
    else
      if arms_cooldowns[2] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 2
        lowCooldown = arms_cooldowns[2]      
      end
    end
  end
  
  -- #3
  if Enraged:ValidityCheckArms(3) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,3) == 0 then
      if arms_cooldowns[3] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 3
        lowCooldown = arms_cooldowns[3]
      end
    else
      if arms_cooldowns[3] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 3
        lowCooldown = arms_cooldowns[3]      
      end
    end
  end
  
  -- #4
  if Enraged:ValidityCheckArms(4) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,4) == 0 then
      if arms_cooldowns[4] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 4
        lowCooldown = arms_cooldowns[4]
      end
    else
      if arms_cooldowns[4] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 4
        lowCooldown = arms_cooldowns[4]      
      end
    end
  end
  
  -- #5
  if Enraged:ValidityCheckArms(5) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,5) == 0 then
      if arms_cooldowns[5] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 5
        lowCooldown = arms_cooldowns[5]
      end
    else
      if arms_cooldowns[5] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 5
        lowCooldown = arms_cooldowns[5]      
      end
    end
  end
  
  -- #6
  if Enraged:ValidityCheckArms(6) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,6) == 0 then
      if arms_cooldowns[6] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 6
        lowCooldown = arms_cooldowns[6]
      end
    else
      if arms_cooldowns[6] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 6
        lowCooldown = arms_cooldowns[6]      
      end
    end
  end
  
  -- #7
  if Enraged:ValidityCheckArms(7) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,7) == 0 then
      if arms_cooldowns[7] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 7
        lowCooldown = arms_cooldowns[7]
      end
    else
      if arms_cooldowns[7] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 7
        lowCooldown = arms_cooldowns[7]      
      end
    end
  end
  
  -- #8
  if Enraged:ValidityCheckArms(8) == 0 then
    if Enraged:ComparePrioritiesArms(lowSlot,8) == 0 then
      if arms_cooldowns[8] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 8
        lowCooldown = arms_cooldowns[8]
      end
    else
      if arms_cooldowns[8] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 8
        lowCooldown = arms_cooldowns[8]      
      end
    end
  end  
  
  if lowCooldown == 999 then
    lowSlot = 9999
  end
  
  -- Update Ability
  local ability = Enraged:GetAbilityByNumArms(lowSlot)
  if slot == 1 then
    ability1Frame.ability = ability
  end
  if slot == 2 then
    ability2Frame.ability = ability
  end
  
  -- Update Slot and Cooldown
  slots[slot] = 1
  Enraged:IncreaseCooldownArms(lowSlot)
end

function Enraged:IncreaseCooldownArms(num)
  if num == 1 then -- rend
    arms_cooldowns[1] = arms_cooldowns[1] + 999 -- show on bar only once
  end
  if num == 2 then -- colossus smash
    arms_cooldowns[2] = arms_cooldowns[2] + 20
  end
  if num == 3 then -- mortal strike
    arms_cooldowns[3] = arms_cooldowns[3] + 4.5
  end
  if num == 4 then -- overpower
    arms_cooldowns[4] = arms_cooldowns[4] + 999 -- we'll let OP show up as a proc for now, no TfB tick calculations
  end 
  if num == 5 then -- execute
    arms_cooldowns[5] = arms_cooldowns[5] + theGCD
  end
  if num == 6 then -- slam
    arms_cooldowns[6] = arms_cooldowns[6] + theGCD
  end
  if num == 7 then -- heroic strike
    arms_cooldowns[7] = arms_cooldowns[4] + 999 -- we only want to show HS on the bar once
  end  -- there is rage to consider after all  
  if num == 8 then
    arms_cooldowns[8] = 999 -- only show once
  end
  if num == 9 then
    arms_cooldowns[9] = 999
  end
end

function Enraged:ComparePrioritiesArms(lowSlot, newSlot)
  local lowSlotPriority = Enraged:GetPriorityByNumArms(lowSlot)
  local newSlotPriority = Enraged:GetPriorityByNumArms(newSlot)
  if (lowSlotPriority < newSlotPriority) then
    return 1
  else
    return 0
  end
end

function Enraged:GetPriorityByNumArms(slot)
  if Enraged.db.profile.arms_priority_1 == slot then
    return 1
  end
  if Enraged.db.profile.arms_priority_2 == slot then
    return 2
  end
  if Enraged.db.profile.arms_priority_3 == slot then
    return 3
  end
  if Enraged.db.profile.arms_priority_4 == slot then
    return 4
  end
  if Enraged.db.profile.arms_priority_5 == slot then
    return 5
  end
  if Enraged.db.profile.arms_priority_6 == slot then
    return 6
  end
  if Enraged.db.profile.arms_priority_7 == slot then
    return 7
  end 
  if Enraged.db.profile.arms_priority_8 == slot then
    return 8
  end
  if Enraged.db.profile.arms_priority_9 == slot then
    return 9
  end
  -- default
  return 999
end

function Enraged:GetAbilityByNumArms(num)
  if num == 1 then -- execute
    return Enraged.debuffs.rend
  end
  if num == 2 then -- colossus smash
    return Enraged.common.csmash
  end
  if num == 3 then -- mortal strike
    return Enraged.arms.ms
  end
  if num == 4 then -- overpower
    return Enraged.arms.op
  end
  if num == 5 then -- execute
    return Enraged.common.exec
  end
  if num == 6 or num == 999 then -- slam
    return Enraged.common.slam
  end
  if num == 7 then -- heroic strike
    return Enraged.common.hstrike
  end
  if num == 8 then -- hamstring
    return Enraged.common.hstring
  end
  if num == 9 then
    return Enraged.arms.ms -- not used
  end
end

------------------------------------
-- Update the DPS Priority Queue (Prot)
------------------------------------
function Enraged:UpdateQueueProt()
  -- Find the current GCD
  local currentStart,currentBaseGCD = GetSpellCooldown(Enraged.debuffs.sunder.spell[1])
  local currentGCD = 0
  if (currentStart > 0) then
    currentGCD = currentBaseGCD - (GetTime() - currentStart)
  else
    currentGCD = 0
  end
  
  -- Set CD's of our spell array back to 0
  Enraged:UpdateCooldownsProt(currentGCD)
  
  -- Iterate through 1-3
  for i = 1,3 do
    Enraged:FindLowestCooldownProt(i)
  end
  
  -- Check for shouts
  if (UnitMana("player") < 20) then
    shout, _, _ = GetSpellCooldown(Enraged.shouts.battle.spell[1])
    if (shout == 0) then
      if (ability1Frame.ability ~= Enraged.fury.rageblow) then
        if (Enraged.db.profile.suggest_shout == 2) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.shouts.battle
        end
        if (Enraged.db.profile.suggest_shout == 3) then
          Enraged:pushbackAbilities(1)
          ability1Frame.ability = Enraged.shouts.command
        end
      end
    end
  end
end

function Enraged:UpdateCooldownsProt(currentGCD)
  -- Demo Shout
  local protStart,protBaseCD = GetSpellCooldown(Enraged.debuffs.demo.spell[1])
  if (protStart > 0) then
    prot_cooldowns[1] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[1] = 0
  end
  
  -- Shockwave
  protStart,protBaseCD = GetSpellCooldown(Enraged.prot.swave.spell[1])
  if (protStart > 0) then
    prot_cooldowns[2] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[2] = 0
  end
  
  -- Victory Rush
  protStart,protBaseCD = GetSpellCooldown(Enraged.prot.vrush.spell[1])
  if (protStart > 0) then
    prot_cooldowns[3] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[3] = 0
  end
  
  -- Revenge
  protStart,protBaseCD = GetSpellCooldown(Enraged.prot.revenge.spell[1])
  if (protStart > 0) then
    prot_cooldowns[4] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[4] = 0
  end
  
  -- Shield Slam
  protStart,protBaseCD = GetSpellCooldown(Enraged.prot.shield.spell[1])
  if (protStart > 0) then
    prot_cooldowns[5] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[5] = 0
  end
  
  -- Rend
  protStart,protBaseCD = GetSpellCooldown(Enraged.debuffs.rend.spell[1])
  if (protStart > 0) then
    prot_cooldowns[6] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[6] = 0
  end
  
  -- Thunderclap
  protStart,protBaseCD = GetSpellCooldown(Enraged.debuffs.tclap.spell[1])
  if (protStart > 0) then
    prot_cooldowns[7] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[7] = 0
  end
  
  -- Devastate
  protStart,protBaseCD = GetSpellCooldown(Enraged.prot.dev.spell[1])
  if (protStart > 0) then
    prot_cooldowns[8] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[8] = 0
  end
  
  -- Heroic Strike
  protStart,protBaseCD = GetSpellCooldown(Enraged.common.hstrike.spell[1])
  if (protStart > 0) then
    prot_cooldowns[9] = protBaseCD - (GetTime() - protStart)
  else
    prot_cooldowns[9] = 0
  end
  
  -- None
  prot_cooldowns[10] = 999
end

function Enraged:FindLowestCooldownProt(slot)
  local lowSlot
  local lowCooldown
  
  -- #8 - Devastate (default)
  if Enraged:ValidityCheckProt(8) == 0 then
    lowSlot = 8
    lowCooldown = prot_cooldowns[8]
  else
    lowSlot = 8
    lowCooldown = 999
  end
  
  -- #1
  if Enraged:ValidityCheckProt(1) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,1) == 0 then
      if prot_cooldowns[1] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 1
        lowCooldown = prot_cooldowns[1]
      end
    else
      if prot_cooldowns[1] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 1
        lowCooldown = prot_cooldowns[1]      
      end
    end
  end  
  
  -- #2
  if Enraged:ValidityCheckProt(2) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,2) == 0 then
      if prot_cooldowns[2] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 2
        lowCooldown = prot_cooldowns[2]
      end
    else
      if prot_cooldowns[2] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 2
        lowCooldown = prot_cooldowns[2]      
      end
    end
  end
  
  -- #3
  if Enraged:ValidityCheckProt(3) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,3) == 0 then
      if prot_cooldowns[3] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 3
        lowCooldown = prot_cooldowns[3]
      end
    else
      if prot_cooldowns[3] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 3
        lowCooldown = prot_cooldowns[3]      
      end
    end
  end
  
  -- #4
  if Enraged:ValidityCheckProt(4) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,4) == 0 then
      if cooldowns[4] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 4
        lowCooldown = prot_cooldowns[4]
      end
    else
      if cooldowns[4] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 4
        lowCooldown = prot_cooldowns[4]      
      end
    end
  end
  
  -- #5
  if Enraged:ValidityCheckProt(5) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,5) == 0 then
      if prot_cooldowns[5] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 5
        lowCooldown = prot_cooldowns[5]
      end
    else
      if prot_cooldowns[5] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 5
        lowCooldown = prot_cooldowns[5]      
      end
    end
  end
  
  -- #6
  if Enraged:ValidityCheckProt(6) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,6) == 0 then
      if prot_cooldowns[6] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 6
        lowCooldown = prot_cooldowns[6]
      end
    else
      if prot_cooldowns[6] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 6
        lowCooldown = prot_cooldowns[6]      
      end
    end
  end
  
  -- #7
  if Enraged:ValidityCheckProt(7) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,7) == 0 then
      if prot_cooldowns[7] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 7
        lowCooldown = prot_cooldowns[7]
      end
    else
      if prot_cooldowns[7] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 7
        lowCooldown = prot_cooldowns[7]      
      end
    end
  end
  
  -- #8 is done first, since dev is spammable
  
  -- #9
  if Enraged:ValidityCheckProt(9) == 0 then
    if Enraged:ComparePrioritiesProt(lowSlot,9) == 0 then
      if prot_cooldowns[9] < lowCooldown + Enraged.db.profile.ability_buffer then
        lowSlot = 9
        lowCooldown = prot_cooldowns[9]
      end
    else
      if prot_cooldowns[9] + Enraged.db.profile.ability_buffer < lowCooldown then
        lowSlot = 9
        lowCooldown = prot_cooldowns[9]      
      end
    end
  end    
  
  -- Update Ability
  local ability = Enraged:GetAbilityByNumProt(lowSlot)
  if slot == 1 then
    ability1Frame.ability = ability
  end
  if slot == 2 then
    ability2Frame.ability = ability
  end
  if slot == 3 then
    ability3Frame.ability = ability
  end 
  
  -- Update Slot and Cooldown
  slots[slot] = 1
  Enraged:IncreaseCooldownProt(lowSlot)
end

function Enraged:ComparePrioritiesProt(lowSlot, newSlot)
  local lowSlotPriority = Enraged:GetPriorityByNumProt(lowSlot)
  local newSlotPriority = Enraged:GetPriorityByNumProt(newSlot)
  if (lowSlotPriority < newSlotPriority) then
    return 1
  else
    return 0
  end
end

function Enraged:GetPriorityByNumProt(slot)
  if Enraged.db.profile.prot_priority_1 == slot then
    return 1
  end
  if Enraged.db.profile.prot_priority_2 == slot then
    return 2
  end
  if Enraged.db.profile.prot_priority_3 == slot then
    return 3
  end
  if Enraged.db.profile.prot_priority_4 == slot then
    return 4
  end
  if Enraged.db.profile.prot_priority_5 == slot then
    return 5
  end
  if Enraged.db.profile.prot_priority_6 == slot then
    return 6
  end
  if Enraged.db.profile.prot_priority_7 == slot then
    return 7
  end
  if Enraged.db.profile.prot_priority_8 == slot then
    return 8
  end
  if Enraged.db.profile.prot_priority_9 == slot then
    return 9
  end
  if Enraged.db.profile.prot_priority_10 == slot then
    return 10
  end
  -- default
  return 999
end

function Enraged:IncreaseCooldownProt(num)
  if num == 1 then -- demo shout
    prot_cooldowns[1] = prot_cooldowns[1] + 45
  end
  if num == 2 then -- shockwave
    prot_cooldowns[2] = prot_cooldowns[2] + 20
  end
  if num == 3 then -- victory rush
    -- no CD on victory rush
    prot_cooldowns[3] = prot_cooldowns[3] + 999 -- show once
  end
  if num == 4 then -- revenge
    prot_cooldowns[4] = prot_cooldowns[4] + 5
  end
  if num == 5 then -- shield slam
    prot_cooldowns[5] = prot_cooldowns[5] + 6
  end
  if num == 6 then -- rend
    prot_cooldowns[6] = prot_cooldowns[6] + 999 -- show once
  end
  if num == 7 then -- Thunderclap
    prot_cooldowns[7] = prot_cooldowns[7] + 6
  end
  if num == 8 then -- Devastate
    prot_cooldowns[8] = prot_cooldowns[8] + theGCD
  end
  if num == 9 then -- Heroic Strike
    prot_cooldowns[9] = prot_cooldowns[9] + 3
  end
  if num == 10 then -- None
    prot_cooldowns[10] = 999
  end
end

function Enraged:GetAbilityByNumProt(num)
  if num == 1 then -- demo shout
    return Enraged.debuffs.demo
  end
  if num == 2 then -- shockwave
    return Enraged.prot.swave
  end
  if num == 3 then -- victory rush
    return Enraged.prot.vrush
  end
  if num == 4 then -- revenge
    return Enraged.prot.revenge
  end
  if num == 5 then -- shield slam
    return Enraged.prot.shield
  end
  if num == 6 then -- rend
    return Enraged.debuffs.rend
  end
  if num == 7 then -- thundre clap
    return Enraged.debuffs.tclap
  end
  if num == 8 then -- devastate
    return Enraged.prot.dev 
  end
  if num == 9 then -- heroic strike
    return Enraged.common.hstrike
  end
  if num == 10 then -- none, won't hit
    return Enraged.prot.dev
  end
end

function Enraged:ValidityCheckProt(priority)
  -- If the user even wants to display this ability
  if Enraged:GetPriorityByNumProt(priority) == 999 then
    return 1
  end
    
  -- Demo Shout
  if priority == 1 then
    if inCombat == false or (GetTime() - timeEnteringCombat) < Enraged.db.profile.time_in_combat then
      return 1
    end
    if (demoET ~= nil and (demoET - GetTime()) > 3) then
      return 1
    end
  end
  
  -- Shockwave
  if priority == 2 then
    local _,_,_,tsCount,_,_,tsET,_,_ = UnitAura("player", Enraged.prot.tstruck1.spell[2])    
    if (tsCount == nil) then
      _,_,_,tsCount,_,_,tsET,_,_ = UnitAura("player", Enraged.prot.tstruck2.spell[2])    
    end
    if Enraged.db.profile.sw_stacks < 4 and (tsCount == nil or tsCount < Enraged.db.profile.sw_stacks) then
      return 1
    end
  end
  
  -- Victory Rush
  if (priority == 3) then
    local _,_,_,imCount,_,_,imET,_,_ = UnitAura("player", Enraged.prot.impend1.spell[2])    
    if (imCount == nil) then
      _,_,_,imCount,_,_,imET,_,_ = UnitAura("player", Enraged.prot.impend2.spell[2])    
    end
    if (imCount == nil) then
      return 1
    end    
  end
  
  -- Revenge -- TODO: this
  if (priority == 4) then  
    -- Check for improved revenge, if we want
    local _,_,_,_,rank,_,_,_,_,_ = GetTalentInfo(3,12)
    if (rank == 0 and Enraged.db.profile.revenge_override == true) then
      return 1
    end
    -- Check for usability
    if IsUsableSpell(Enraged.prot.revenge.spell[1]) == nil then
      return 1
    end
  end
  
  -- Shield Slam
  if (priority == 5) then
  end
  
  -- Rend
  if (priority == 6) then
    local _,_,_,rendCount,_,_,rendET,_,_ = UnitDebuff("target", Enraged.debuffs.rend.spell[2])
    if (rendET == nil and enragedFrame.aoeToggle:GetValue() == true) then
      return 0
    end
    if inCombat == false or ((GetTime() - timeEnteringCombat) < Enraged.db.profile.time_in_combat) then
      return 1
    end  
    if (rendET ~= nil) then
      return 1
    end    
  end
  
  -- Thunderclap
  if (priority == 7) then
    -- return true for AOE mode
    if (enragedFrame.aoeToggle:GetValue() == true) then
      return 0
    end
    -- Make sure we are in combat for X seconds
    if inCombat == false or ((GetTime() - timeEnteringCombat) < Enraged.db.profile.time_in_combat) then
      return 1
    end
    local _,_,_,rendCount,_,_,rendET,_,_ = UnitDebuff("target", Enraged.debuffs.rend.spell[2])
    -- Check TC and Rend. Only return false when both are stable
    if (thunderET ~= nil and rendET ~= nil and (rendET - GetTime()) > 3 and (thunderET - GetTime()) > 3) then
      return 1
    end    
  end
  
  -- Devastate
  if (priority == 8) then

  end
  
  -- Heroic Strike
  if (priority == 9) then
    if Enraged.db.profile.suggest_hs == false then
      return 1
    end
    if (UnitMana("player") < Enraged.db.profile.hs_threshold_prot) then
      return 1
    end
  end
  
  return 0
end

------------------------------------
-- Refresh textures in the DPS queue
------------------------------------
function Enraged:refreshTextures()
  ability1Frame.texture:SetTexture(ability1Frame.ability.spell[3])
  ability2Frame.texture:SetTexture(ability2Frame.ability.spell[3])
  ability3Frame.texture:SetTexture(ability3Frame.ability.spell[3])
  buffsEnrage.texture:SetTexture(buffsEnrage.ability.spell[3])
  buffsSunder.texture:SetTexture(buffsSunder.ability.spell[3])
  buffsThunder.texture:SetTexture(buffsThunder.ability.spell[3])
  buffsDemo.texture:SetTexture(buffsDemo.ability.spell[3])
  if (talentSpec == 1) then
    ability3Frame:Hide()
    ability3Frame.cooldown:Hide()
  elseif ((talentSpec == 3 or talentSpec == 2) and self.frame:IsShown() ~= nil) then
    ability3Frame:Show()
    ability3Frame.cooldown:Show()
  end
end

------------------------------------
-- Pushback abilities down the queue,
-- starting from the given index
------------------------------------
function Enraged:pushbackAbilities(index)
  local ability1 = ability1Frame.ability
  local ability2 = ability2Frame.ability
  
  if (index == 1) then
    ability2Frame.ability = ability1
    ability3Frame.ability = ability2
    if (ability2Frame:IsShown() == nil) then
      ability2Frame:Show()
    end    
    if (ability3Frame:IsShown() == nil) then
      ability3Frame:Show()
    end
  end
   
  if (index == 2) then
    ability3Frame.ability = ability2
    if (ability3Frame:IsShown() == nil) then
      ability3Frame:Show()
    end    
  end
end

------------------------------------
-- Update the Cooldowns on the DPS
-- abilitiy queue.
------------------------------------
function Enraged:UpdateCDs()
	local start, duration = GetSpellCooldown(ability1Frame.ability.spell[1])
	if duration and duration > 0 and inCombat == true and ability1Frame:IsShown() ~= nil then
		ability1Frame.cooldown:SetCooldown(start, duration)
		ability1Frame.cooldown:Show()
  else
    ability1Frame.cooldown:Hide()
  end
  
  start, duration = GetSpellCooldown(ability2Frame.ability.spell[1])
  if duration and duration > 0 and inCombat == true and ability2Frame:IsShown() ~= nil then
    ability2Frame.cooldown:SetCooldown(start, duration)
		ability2Frame.cooldown:Show()
	else
    ability2Frame.cooldown:Hide()
  end
   
  start, duration = GetSpellCooldown(ability3Frame.ability.spell[1])
  if duration and duration > 0 and inCombat == true and ability3Frame:IsShown() ~= nil then
  	ability3Frame.cooldown:SetCooldown(start, duration)
		ability3Frame.cooldown:Show()
  else
    ability3Frame.cooldown:Hide() 
	end
  
  -- Heroic Strike Frame
	start, duration = GetSpellCooldown(Enraged.common.hstrike.spell[1])
	if duration and duration > 0 and inCombat == true and hsFrame.Ability:IsShown() ~= nil then
		hsFrame.Ability.cooldown:SetCooldown(start, duration)
		hsFrame.Ability.cooldown:Show()
  else
    hsFrame.Ability.cooldown:Hide()
  end  
end

-------------------------------------
-- Update Buff/Debuff durations and 
-- change opacities based on them
-------------------------------------
function Enraged:UpdateBuffFrame()
  -- Update Buff Icon for Fury
  if (talentSpec == 2) then
    buffsEnrage.ability,buffsEnrage.TR,buffsEnrage.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.buffs_1)
    buffsSunder.ability,buffsSunder.TR,buffsSunder.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.buffs_2)
    buffsThunder.ability,buffsThunder.TR,buffsThunder.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.buffs_3)
    buffsDemo.ability,buffsDemo.TR,buffsDemo.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.buffs_4)
  end
  
  -- Update Buff Icon for Arms
  if (talentSpec == 1) then
    buffsEnrage.ability,buffsEnrage.TR,buffsEnrage.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.arms_buffs_1)
    buffsSunder.ability,buffsSunder.TR,buffsSunder.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.arms_buffs_2)
    buffsThunder.ability,buffsThunder.TR,buffsThunder.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.arms_buffs_3)
    buffsDemo.ability,buffsDemo.TR,buffsDemo.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.arms_buffs_4)
  end
  
  -- Update Buff Icon for Prot
  if (talentSpec == 3) then
    buffsEnrage.ability,buffsEnrage.TR,buffsEnrage.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.prot_buffs_1)
    buffsSunder.ability,buffsSunder.TR,buffsSunder.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.prot_buffs_2)
    buffsThunder.ability,buffsThunder.TR,buffsThunder.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.prot_buffs_3)
    buffsDemo.ability,buffsDemo.TR,buffsDemo.stacknum = Enraged:GetBuffInfo(Enraged.db.profile.prot_buffs_4)
  end
  
  -- Update Buff Text
  Enraged:UpdateBuffText(buffsEnrage)
  Enraged:UpdateBuffText(buffsSunder)
  Enraged:UpdateBuffText(buffsThunder)
  Enraged:UpdateBuffText(buffsDemo)
  
  -- Hide/Show
  if (talentSpec == 2 and Enraged.db.profile.buffs_1 == 17) or
     (talentSpec == 1 and Enraged.db.profile.arms_buffs_1 == 17) or
     (talentSpec == 3 and Enraged.db.profile.prot_buffs_1 == 17) then
    buffsEnrage:Hide()
  else
    buffsEnrage:Show()
  end
  
  if (talentSpec == 2 and Enraged.db.profile.buffs_2 == 17) or
     (talentSpec == 1 and Enraged.db.profile.arms_buffs_2 == 17) or
     (talentSpec == 3 and Enraged.db.profile.prot_buffs_2 == 17) then
    buffsSunder:Hide()
  else
    buffsSunder:Show()
  end
  
  if (talentSpec == 2 and Enraged.db.profile.buffs_3 == 17) or
     (talentSpec == 1 and Enraged.db.profile.arms_buffs_3 == 17) or
     (talentSpec == 3 and Enraged.db.profile.prot_buffs_3 == 17) then
    buffsThunder:Hide()
  else
    buffsThunder:Show()
  end

  if (talentSpec == 2 and Enraged.db.profile.buffs_4 == 17) or
     (talentSpec == 1 and Enraged.db.profile.arms_buffs_4 == 17) or
     (talentSpec == 3 and Enraged.db.profile.prot_buffs_4 == 17) then
    buffsDemo:Hide()
  else
    buffsDemo:Show()
  end
end

function Enraged:UpdateBuffText(bf)
  if (bf.TR ~= nil) then
    bf:SetAlpha(1)
    bf.texture:SetTexture(bf.ability.spell[3])
    if (bf.stacknum > 0) then
      bf.stack:SetText(bf.stacknum)
    else
      bf.stack:SetText("")
    end 
    if ((bf.TR - GetTime()) <= 9.5) then
      bf.time:ClearAllPoints()
      bf.time:SetPoint("LEFT", bf, "LEFT", 10 * self.db.profile.buff_scale, 0)
      bf.stack:ClearAllPoints()
      bf.stack:SetPoint("BOTTOMRIGHT", bf, "BOTTOMRIGHT", -1 * self.db.profile.buff_scale, 1 * self.db.profile.buff_scale)
    else
      bf.time:ClearAllPoints()
      bf.time:SetPoint("LEFT", bf, "LEFT", 6 * self.db.profile.buff_scale, 0)    
    end
    bf.time:SetText(format("%.0f",bf.TR - GetTime()))
  else
    bf.texture:SetTexture(bf.ability.spell[3])
    bf.time:SetText("")
    bf.stack:SetText("")
    bf:SetAlpha(0.3)
  end
end

function Enraged:GetBuffInfo(num)
  -- Enrages
  if (num == 1) then
    return enrageIcon,enrageET,0
  end
  
  -- Sunder
  if num == 2 then
    return sunderIcon,sunderET,sunderCount
  end
    
  -- Meat Cleaver
  if num == 3 then
    local _,_,_,mcCount,_,_,mcET,_,_ = UnitAura("player", Enraged.fury.meatclvr.spell[2])    
    return Enraged.fury.meatclvr,mcET,mcCount
  end
  
  -- Demo shout
  if num == 4 then
    return demoIcon,demoET,demoCount
  end
  
  -- Rend
  if num == 5 then
    local _,_,_,rendCount,_,_,rendET,_,_ = UnitDebuff("target", Enraged.debuffs.rend.spell[2])    
    return Enraged.debuffs.rend,rendET,rendCount
  end
  
  -- Thunder Clap
  if num == 6 then
    return thunderIcon,thunderET,thunderCount
  end
  
  -- Taste for Blood
  if num == 7 then
    local _,_,_,tfbCount,_,_,tfbET,_,_ = UnitAura("player", Enraged.arms.tfb.spell[2])    
    return Enraged.arms.tfb,tfbET,tfbCount
  end
  
  -- Incite
  if num == 8 then
    -- Rank 1
    local _,_,_,incCount,_,_,incET,_,_ = UnitAura("player", Enraged.common.incite1.spell[2])
    if incET ~= nil then
      return Enraged.common.incite1,incET,incCount
    end
    
    -- Rank 2
    _,_,_,incCount,_,_,incET,_,_ = UnitAura("player", Enraged.common.incite2.spell[2])
    if incET ~= nil then
      return Enraged.common.incite2,incET,incCount
    end
    
    -- Rank 3
    _,_,_,incCount,_,_,incET,_,_ = UnitAura("player", Enraged.common.incite3.spell[2])
    return Enraged.common.incite3,incET,incCount    
  end
  
  -- Battle Trance
  if num == 9 then
    local _,_,_,btCount,_,_,btET,_,_ = UnitAura("player", Enraged.fury.btrance.spell[2])    
    return Enraged.fury.btrance,btET,btCount    
  end
  
  -- Executioner
  if num == 10 then
    local _,_,_,execCount,_,_,execET,_,_ = UnitAura("player", Enraged.common.exstack.spell[2])    
    return Enraged.common.exstack,execET,execCount   
  end
  
  -- Lambs to the Slaughter
  if num == 11 then
    -- Rank 1
    local _,_,_,lambCount,_,_,lambET,_,_ = UnitAura("player", Enraged.arms.lamb1.spell[2])
    if lambET ~= nil then
      return Enraged.arms.lamb1,lambET,lambCount
    end
    
    -- Rank 2
    _,_,_,lambCount,_,_,lambET,_,_ = UnitAura("player", Enraged.arms.lamb2.spell[2])
    if lambET ~= nil then
      return Enraged.arms.lamb2,lambET,lambCount
    end
    
    -- Rank 3
    _,_,_,lambCount,_,_,lambET,_,_ = UnitAura("player", Enraged.arms.lamb3.spell[2])
    return Enraged.arms.lamb3,lambET,lambCount 
  end
  
  -- Inner Rage
  if num == 12 then
    local _,_,_,irCount,_,_,irET,_,_ = UnitAura("player", Enraged.common.irage.spell[2])
    return Enraged.common.irage,irET,irCount
  end
  
  -- Slam
  if num == 13 then
    local _,_,_,bsCount,_,_,bsET,_,_,_,_ = UnitAura("player", Enraged.fury.bsurge.spell[2])
    return Enraged.fury.bsurge,bsET,bsCount
  end
  
  -- Thunderstruck
  if num == 14 then
    -- Rank 1
    local _,_,_,tsCount,_,_,tsET,_,_ = UnitAura("player", Enraged.prot.tstruck1.spell[2])
    if incET ~= nil then
      return Enraged.prot.tstruck1,tsET,tsCount
    end
    
    -- Rank 2
    _,_,_,incCount,_,_,incET,_,_ = UnitAura("player", Enraged.prot.tstruck2.spell[2])
      return Enraged.prot.tstruck2,tsET,tsCount
  end
  
  -- Impending Victory
  if num == 15 then
    -- Rank 1
    local _,_,_,ivCount,_,_,ivET,_,_ = UnitAura("player", Enraged.prot.impend1.spell[2])
    if incET ~= nil then
      return Enraged.prot.impend1,ivET,ivCount
    end
    
    -- Rank 2
    _,_,_,incCount,_,_,ivET,_,_ = UnitAura("player", Enraged.prot.impend2.spell[2])
    return Enraged.prot.impend2,ivET,ivCount    
  end
  
  -- Rage of the Ages (T11)
  if num == 16 then
    local _,_,_,roaCount,_,_,roaET,_,_,_,_ = UnitAura("player",Enraged.common.roa.spell[2])
    return Enraged.common.roa,roaET,roaCount    
  end
  
  -- None "------------"
  if num == 17 then
    return Enraged.fury.bthirst,nil,nil
  end
end

-------------------------------------------------
-- Check if your current target is in melee range
--------------------------------------------------
function Enraged:UpdateOOR()
  local hthrowCD = GetSpellCooldown(Enraged.common.hthrow.spell[1])
  local meleeRange = IsSpellInRange(Enraged.debuffs.sunder.spell[2], "target") -- Spell available in all stances, all specs
  local throwRange = IsSpellInRange(Enraged.common.hthrow.spell[2], "target") -- Spell available in all stances, all specs
  if meleeRange ~= nil and meleeRange == 0 then
    if (hthrowCD == 0) then
      Enraged:pushbackAbilities(1)
      ability1Frame.ability = Enraged.common.hthrow
      if (throwRange ~= nil and throwRange == 1) then
        Enraged:ShowAbilitiesUnavailable(true)      
      else
        Enraged:ShowAbilitiesUnavailable(false)
      end  
    else
      Enraged:ShowAbilitiesUnavailable(false)
    end
  else
    Enraged:ShowAbilitiesAvailable(false)
  end
end

function Enraged:UpdateHS()
  -- Check Buffs
  _,_,_,_,_,_,btET,_,_,_,_ = UnitAura("player","Battle Trance")  
  _,_,_,_,_,_,mcET,_,_,_,_ = UnitAura("player","Meat Cleaver")
  local rageThreshold
  
  -- Check the threshold to view
  if talentSpec == 1 then
    rageThreshold = Enraged.db.profile.hs_threshold_arms
  elseif talentSpec == 2 then
    rageThreshold = Enraged.db.profile.hs_threshold
  else
    rageThreshold = Enraged.db.profile.hs_threshold_prot
  end
  
  if (Enraged.db.profile.suggest_btrance == true and btET ~= nil and btET > 0) then
    if (UnitMana("player") < (rageThreshold - 20)) then
      -- Activate
      hsFrame.Ability:SetAlpha(0.3)
      rageBar:SetStatusBarColor(1,0,0,1)
    end
  else
    if (UnitMana("player") < rageThreshold) then
      -- Activate
      hsFrame.Ability:SetAlpha(0.3)
      rageBar:SetStatusBarColor(1,0,0,1)
    else
      hsFrame.Ability:SetAlpha(1)
      rageBar:SetStatusBarColor(0,1,0,1)      
    end
  end
  
  if Enraged.db.profile.suggest_aoe == true and mcET ~= nil then
    hsFrame.Ability.texture:SetTexture(Enraged.common.cleave.spell[3])
  else
    hsFrame.Ability.texture:SetTexture(Enraged.common.hstrike.spell[3])
  end
end

function Enraged:UpdateMajorBuffs()
  -- Enrages
  _,_,_,_,_,_,enrageET,_,_ = UnitAura("player", Enraged.enraged_effects.deathwish.spell[2])
  isEnraged = true
  if (enrageET == nil) then
    _,_,_,_,_,_,enrageET,_,_ = UnitAura("player", Enraged.enraged_effects.berserk.spell[2])
    if (enrageET == nil) then
      _,_,_,_,_,_,enrageET,_,_ = UnitAura("player", Enraged.enraged_effects.ragebuff.spell[2])
      if (enrageET == nil) then
        isEnraged = false   
        enrageIcon = Enraged.enraged_effects.ragebuff
      else
        enrageIcon = Enraged.enraged_effects.ragebuff
      end
    else
      enrageIcon = Enraged.enraged_effects.berserk
    end
  else
    enrageIcon = Enraged.enraged_effects.deathwish
  end
  
  -- Sunder
  _,_,_,sunderCount,_,_,sunderET,_,_ = UnitDebuff("target", Enraged.debuffs.sunder.spell[2])
  if (sunderET == nil) then
    _,_,_,sunderCount,_,_,sunderET,_,_ = UnitDebuff("target", Enraged.external.ffferal.spell[2])
    if (sunderET == nil) then
      _,_,_,sunderCount,_,_,sunderET,_,_ = UnitDebuff("target", Enraged.external.expose.spell[2])
      if (sunderET == nil) then
        _,_,_,sunderCount,_,_,sunderET,_,_ = UnitDebuff("target", Enraged.external.ff.spell[2])
        if (sunderET == nil) then
          sunderIcon = Enraged.debuffs.sunder
        else
          sunderIcon = Enraged.external.ff
        end
      else
        sunderIcon = Enraged.external.expose
      end
    else
      sunderIcon =  Enraged.external.ffferal
    end
  else
    sunderIcon = Enraged.debuffs.sunder
  end
  
  -- Demo shout
  _,_,_,demoCount,_,_,demoET,_,_ = UnitDebuff("target", Enraged.debuffs.demo.spell[2])
  if (demoET == nil) then
    _,_,_,demoCount,_,_,demoET,_,_ = UnitDebuff("target", Enraged.external.demoroar.spell[2])
    if (demoET == nil) then
      _,_,_,demoCount,_,_,demoET,_,_ = UnitDebuff("target", Enraged.external.petroar.spell[2])
      if (demoET == nil) then
        _,_,_,demoCount,_,_,demoET,_,_ = UnitDebuff("target", Enraged.external.vindic.spell[2])
        if (demoET == nil) then
          _,_,_,demoCount,_,_,demoET,_,_ = UnitDebuff("target", Enraged.external.curse.spell[2])
          if (demoET == nil) then
            _,_,_,demoCount,_,_,demoET,_,_ = UnitDebuff("target", Enraged.external.scarlet.spell[2])            
            if (demoET == nil) then
              demoIcon = Enraged.debuffs.demo
            else
              demoIcon = Enraged.external.scarlet
            end
          else
            demoIcon = Enraged.external.curse
          end
        else
          demoIcon = Enraged.external.vindic
        end
      else
        demoIcon = Enraged.external.petroar
      end
    else
      demoIcon = Enraged.external.demoroar      
    end
  else
    demoIcon = Enraged.debuffs.demo
  end
  
  -- Thunder Clap
  _,_,_,thunderCount,_,_,thunderET,_,_ = UnitDebuff("target", Enraged.debuffs.tclap.spell[2])
  if (thunderET == nil) then
    _,_,_,thunderCount,_,_,thunderET,_,_ = UnitDebuff("target", Enraged.external.frostfever.spell[2])
    if (thunderET == nil) then
      _,_,_,thunderCount,_,_,thunderET,_,_ = UnitDebuff("target", Enraged.external.judgjust.spell[2])
      if (thunderET == nil) then
        _,_,_,thunderCount,_,_,thunderET,_,_ = UnitDebuff("target", Enraged.external.infect.spell[2])
        if (thunderET == nil) then
          _,_,_,thunderCount,_,_,thunderET,_,_ = UnitDebuff("target", Enraged.external.earth.spell[2])
          if (thunderET == nil) then
            thunderIcon = Enraged.debuffs.tclap
          else
            thunderIcon = Enraged.external.earth
          end
        else
          thunderIcon = Enraged.external.infect
        end
      else
        thunderIcon = Enraged.external.judgjust
      end
    else
      thunderIcon = Enraged.external.frostfever
    end
  else
    thunderIcon = Enraged.debuffs.tclap
  end  
end